Package: RMX
Type: Package
Title: Rasch Models -- eXtensions
Version: 0.1-7
Date: 2026-05-17
Authors@R: c(person(given = "Milica",                       
                    family = "Kabic",                       
                    role = "aut"),                          
             person(given = c("Rainer", "W."),              
                    family = "Alexandrowicz",               
                    role = c("aut", "cre"),                 
                    email = "rainer.alexandrowicz@aau.at")) 
Description: 
 Extend Rasch and Item Response Theory (IRT) analyses by providing  
 tools for post-processing the output from five major IRT packages  
 (i.e., 'eRm', 'psychotools', 'ltm', 'mirt', and 'TAM').            
 The current version provides the plotPIccc() function, which       
 extracts from the return object of the originating package all     
 information required to draw an extended Person-Item-Map (PIccc),  
 showing any combination of                                         
 * category characteristic curves (CCCs),                           
 * threshold characteristic curves (TCCs),                          
 * item characteristic curves (ICCs),                               
 * category information functions (CIFs),                           
 * item information functions (IIFs),                               
 * test information function (TIF), and the                         
 * standard error curve (S.E.).                                     
 for uni- and multidimensional models (as far as supported by each  
 package). It allows for selecting dimensions, items, and categories
 to plot and offers numerous options to adapt the output. The return
 object contains all calculated values for further processing.      
Depends: R (>= 4.1.0)
License: GPL (>= 3)
Suggests: eRm, psychotools, ltm, mirt, TAM
LazyData: true
NeedsCompilation: no
Packaged: 2026-05-17 18:10:29 UTC; aa
Author: Milica Kabic [aut],
  Rainer W. Alexandrowicz [aut, cre]
Maintainer: Rainer W. Alexandrowicz <rainer.alexandrowicz@aau.at>
Repository: CRAN
Date/Publication: 2026-05-19 07:50:10 UTC
Built: R 4.6.0; ; 2026-05-19 11:15:15 UTC; unix

Package: RMX
Type: Package
Title: Rasch Models -- eXtensions
Version: 0.1-7
Date: 2026-05-17
Authors@R: c(person(given = "Milica",                       
                    family = "Kabic",                       
                    role = "aut"),                          
             person(given = c("Rainer", "W."),              
                    family = "Alexandrowicz",               
                    role = c("aut", "cre"),                 
                    email = "rainer.alexandrowicz@aau.at")) 
Description: 
 Extend Rasch and Item Response Theory (IRT) analyses by providing  
 tools for post-processing the output from five major IRT packages  
 (i.e., 'eRm', 'psychotools', 'ltm', 'mirt', and 'TAM').            
 The current version provides the plotPIccc() function, which       
 extracts from the return object of the originating package all     
 information required to draw an extended Person-Item-Map (PIccc),  
 showing any combination of                                         
 * category characteristic curves (CCCs),                           
 * threshold characteristic curves (TCCs),                          
 * item characteristic curves (ICCs),                               
 * category information functions (CIFs),                           
 * item information functions (IIFs),                               
 * test information function (TIF), and the                         
 * standard error curve (S.E.).                                     
 for uni- and multidimensional models (as far as supported by each  
 package). It allows for selecting dimensions, items, and categories
 to plot and offers numerous options to adapt the output. The return
 object contains all calculated values for further processing.      
Depends: R (>= 4.1.0)
License: GPL (>= 3)
Suggests: eRm, psychotools, ltm, mirt, TAM
LazyData: true
NeedsCompilation: no
Packaged: 2026-05-17 18:10:29 UTC; aa
Author: Milica Kabic [aut],
  Rainer W. Alexandrowicz [aut, cre]
Maintainer: Rainer W. Alexandrowicz <rainer.alexandrowicz@aau.at>
Repository: CRAN
Date/Publication: 2026-05-19 07:50:10 UTC

drawperson = function(cl_obj,     # person parameters as vector
                 #    pp_how,     # barplot, hist, boxplot, violinplot
                      pp_offy,    # y offset
                      pp_offx,    # x offset
                      pp_col,
                      pp_labs = c("none","abs","rel","den"),
                      pp_den  = TRUE,
                      pp_nam  = "",
                      dd_col  = "black",
                      do_tif  = TRUE,
                      do_se   = TRUE,
                      do_rel  = FALSE,
                      do_stif = TRUE,
                      do_sse  = TRUE,
                      do_srel = FALSE,
                      do_lab  = 4:6,
                      th_min,
                      th_max,
                      th_vec  = seq(th_min,th_max,length.out=101),
                      tifcol  = "seagreen4",    # tifcolNA for omission
                      se_col  = "firebrick4",    # --"--
                      relcol  = "red",
                      tifmax  = "auto",
                      se_max  = "auto",
                      dw,
                      dh,
                      d0,          # left margin for scale
                      wd      = dw-d0,
                      breaks,
                      debug=TRUE
){
  
  if (debug) message("Entering drawperson...")

  pp_vec = cl_obj$person_par

#  stopifnot(pp_how %in% c("barplot", "hist", "boxplot", "violinplot"))

  n   = length(pp_vec)
  sel = which(pp_vec >= th_min & pp_vec <= th_max)

  pp_hist = hist(pp_vec[sel], plot=FALSE, breaks=breaks)
  pp_labs = match.arg(pp_labs)

  hist_den = pp_hist$density
  hist_abs = pp_hist$counts
  hist_rel = 100*hist_abs/n
  hist_mid = pp_hist$mids

  hist_use = switch(pp_labs,
                    "abs"  = hist_abs, #*0.95*dh/max(hist_abs),
                    "rel"  = hist_rel, #*0.95*dh/max(hist_rel),
                    "den"  = hist_den, #*0.95*dh/max(hist_den),
                    "none" = hist_abs) #*0.95*dh/max(hist_abs))

  hist_fac = 0.95*dh/max(hist_use)
  hist_val = hist_use*hist_fac

  dens_fac = 0.95*dh/max(hist_den)
  dens_val = density(pp_vec,from=th_min,to=th_max,na.rm=TRUE)
  dens_thx = dens_val$x
  dens_thy = dens_val$y * dens_fac

#  f_scale  = dh/max(hist_den)*0.95
#  dens_rel = hist_den * f_scale

#  if(pp_how == "hist"){

     K = length(pp_hist$breaks)
     rect( xleft   = pp_hist$breaks[-K],             # histogram boxes
           ybottom = rep(pp_offy, K-1),
           xright  = pp_hist$breaks[-1],
           ytop    = pp_offy + hist_val, #dens_rel,
           col     = pp_col)

     if (pp_den) lines(dens_thx,pp_offy+dens_thy,col=dd_col,lwd=2)

     if (pp_labs == "rel") hist_shw=paste(round(hist_use,2),"%") else hist_shw=round(hist_use,2)
     if (pp_labs != "none") {
         text(pp_hist$mid, pp_offy + hist_val, hist_shw,cex=0.6,adj=c(-0.2,0.5),srt=90)
         text(th_min+0.1*(th_max-th_min)     , pp_offy + dh, paste0(pp_nam,"\nn=",n),cex=0.8,adj=c(0,1))
     } # end if labels

#  }else if(pp_how == "boxplot"){
#         # to come...
#  } # end if/else


# TODO: legend for TIF / SE if axes omitted

    if (4 %in% do_lab) {
        xt = round(seq(0,max(hist_use),length.out=5))
        segments(d0        , pp_offy+xt*hist_fac,
                 d0+0.01*dw, pp_offy+xt*hist_fac)
        text(    d0+0.02*dw, pp_offy+xt*hist_fac, xt,cex=0.4,adj=c(-0.3,0.5))
    } # end if do_lab 4

    # --- TIF
      tifo  = cl_obj$TIF                      # original TIF

      if (tifmax=="auto") {                   # 2024-07-08 [RWA]
          tifm = max(tifo[is.finite(tifo)])
      } else {
          tifm = tifmax
      }

      tifs  = pp_offy + dh*tifo/tifm          # scaled

    # --- sTIF
      stifo = cl_obj$sTIF                     # original sTIF
      stifs = pp_offy + dh*stifo/tifm         # scaled

    # --- SE
      se_o  = cl_obj$SE                       # original SE

      if (se_max=="auto") {                   # 2024-07-08 [RWA]
          se_m = max(se_o[is.finite(se_o)])
      } else {
          se_m = se_max
      }

      se_s  = pp_offy + dh*se_o/se_m          # scaled

    # --- sSE
      sse_o = cl_obj$sSE                      # original sSE
      sse_s = pp_offy + dh*sse_o/se_m         # scaled
      sse_s[sse_s > max(se_s[is.finite(se_s)])] = NA # cut at upper border


    # --- REL
      rels = pp_offy + dh*cl_obj$REL

    # --- sREL
      srels = pp_offy + dh*cl_obj$sREL


    # --- draw lines
      if (do_tif)  lines(th_vec, tifs,  lwd=2, col=tifcol)
      if (do_stif) lines(th_vec, stifs, lwd=2, col=tifcol, lty=2)
      if (do_se)   lines(th_vec, se_s,  lwd=2, col=se_col)
      if (do_sse)  lines(th_vec, sse_s, lwd=2, col=se_col, lty=2)
      if (do_rel)  lines(th_vec, rels,  lwd=2, col=relcol)
      if (do_srel) lines(th_vec, srels, lwd=2, col=relcol, lty=2)

    # --- prep ticks
      ticw = wd*0.01                          # width of tics
      ticn = 5                                # number of tics
      tics = seq(0,dh,length.out=ticn)        # seqence of tics

    # --- SE & sSE axis, ticks, & labels
      if ((do_se | do_sse) & (5 %in% do_lab)) {
          ticx = th_min
          ticl = round(seq(0,se_m,length.out=ticn),1)                                    # tick pos
          segments(ticx     ,pp_offy     ,ticx     ,pp_offy+dh              ,col=se_col) # axis
          segments(ticx     ,pp_offy+tics,ticx+ticw,pp_offy+tics            ,col=se_col) # ticks
        # segments(ticx     ,pp_offy+tics,ticx-ticw,pp_offy+tics            ,col=se_col) # ticks
          text(    ticx+ticw,pp_offy+tics,ticl      ,cex=0.5,adj=c(-0.2,0.2),col=se_col) # labels
          text(    ticx+ticw,pp_offy+tics[ticn],"SE",cex=0.5,adj=c( 0  ,-1 ),col=se_col) # header
      } # end (s)SE axis

    # --- TIF & sTIF axis, ticks, & labels
      if ((do_tif | do_stif) & (6 %in% do_lab)) {
          ticx = th_max
          ticl = round(seq(0,tifm,length.out=ticn),1)                                    # tick pos
          segments(ticx+ticw,pp_offy     ,ticx+ticw,pp_offy+dh              ,col=tifcol) # axis
          segments(ticx     ,pp_offy+tics,ticx+ticw,pp_offy+tics            ,col=tifcol) # ticks
          text(    ticx     ,pp_offy+tics,ticl       ,cex=0.5,adj=c(1.2,0.2),col=tifcol) # labels
          text(    ticx     ,pp_offy+tics[ticn],"TIF",cex=0.5,adj=c(0.5,-1 ),col=tifcol) # header
      } # end (s)TIF axis

    # --- REL & sREL axis, ticks, & labels
      if ((do_rel | do_srel) & (6 %in% do_lab)) {
          ticx = th_min
          ticl = round(seq(0,1,length.out=ticn),1)                                       # tick pos
#         segments(ticx+ticw,pp_offy     ,ticx+ticw,pp_offy+dh              ,col=relcol) # axis
          segments(ticx     ,pp_offy+tics,ticx-ticw,pp_offy+tics            ,col=relcol) # ticks
          text(    ticx     ,pp_offy+tics,ticl       ,cex=0.5,adj=c(1.6,0.2),col=relcol) # labels
          text(    ticx     ,pp_offy+tics[ticn],"REL",cex=0.5,adj=c(1.2,-1 ),col=relcol) # header
      } # end (s)TIF axis




  if (debug) message("Leaving drawperson...")

}# end fun draw_person    

cleaner = function(dlist, isel=NULL, ilab=NULL, dsel=NULL, dlab=NULL, csel=NULL,
                   how_sort="none", tot_sort=FALSE, theta=seq(-6,6,0.1),highlight=NULL,
                   empirical=NULL,empbins=NULL, empcuts=NULL, smoothargs=NULL, smoothrange=NULL,
                   debug=TRUE){
  
  drange = function(x,na.rm=TRUE) diff(range(x,na.rm=na.rm))

  if (debug) message("Entering cleaner...")
  
  data = attributes(dlist)$data

# ============================================================== TODO: !
#  Fehler in attr(ilab, "was.null") <- TRUE :
#  Versuch ein Attribut von NULL zu setzen
#  if no colnames were provided. pcmodel handles it, but not plotPIccc!
# =====================================================================

  if (is.null(ilab)) {
         ilab = names(dlist$freq)
         attr(ilab, "was.null") = TRUE
  } else {
        attr(ilab, "was.null") = FALSE
        if (length(ilab) > length(dlist$freq)) {
          stop(paste("Too many item labels:",length(ilab),"labels for",length(dlist$freq),"items."))
        } else if (length(ilab) < length(dlist$freq)) {
          stop(paste("Too few item labels:",length(ilab),"labels for",length(dlist$freq),"items."))
        } else if (length(unique(ilab)) < length(ilab)) {
          print(sort(table(ilab)))
          stop(paste("Non-unique item labels."))
        } # end else
  } # end else (not is.null)

  if (!attributes(ilab)$was.null) {
      if ((length(dlist)-1) > 1) {
        stop("Item names cannot be modified for multi-dimensional models.\nYou might want to consider renaming of original data.")
      } else {
        colnames(dlist[[1]]$thresholds)     = ilab
        colnames(dlist[[1]]$discrimination) = ilab
           names(dlist[[1]]$guessing)       = ilab
           names(dlist[[1]]$laziness)       = ilab
           names(dlist[[1]]$model)          = ilab
           names(dlist$freq)                = ilab
        colnames(data)                      = ilab
      } # end else = rename
  } # end rename required

  freq = dlist$freq  # temporarily "outsourced"
  dlist$freq = NULL  # so that length of dlist = no. of dims.!

  if (all(is.null(isel),is.null(dsel),is.null(dlab)))  {  # no user changes

    dlist_sel_itm = dlist
    isel = unlist(lapply(sapply(dlist,"[","thresholds"),colnames))

  } else {     # any changes (isel, dsel, dlab)
    
    # --- 0. Dimension and item labels

    if     (is.null(dlab))                   dlab = names(dlist)
    else if(length(dlab) != length(dlist))   stop(paste0("Invalid length of dlab. \nNumber of labels must equal number of dimensions.\nLabels: ", length(dlab), ", dimensions:", length(dlist), "."),call.=FALSE)
    else if(!is.character(dlab))             dlab = as.character(dlab) 
    
    names(dlist) = dlab
    
    # --- 1. Select dimensions

    if (is.null(dsel)) {

      dlist_sel_dim = dlist

    }else{        # execute dsels
      
      if(anyNA(dsel))           stop("Invalid Input for dsel: Missing values (NA) are not accepted." )
      if(any(duplicated(dsel))) stop("Invalid Input for dsel: Same dimension was selected multiple times.")
      
      if(is.character(dsel)){
        if(all(dsel %in% dlab)){

#         dlist_sel_dim = dlist[dlab]
          dlist_sel_dim = dlist[dsel]  # RWA 23-06-19
          
        }else stop(paste0("Dimension selection did not work: Non-matching dsel values \ndsel: ", dsel, "\ndimension labels: ", dlab, "\n"))
        
      }else if(is.numeric(dsel)){
        
        if(!all(is.int(dsel)))        stop("Invalid Input for dsel: All values need to be integers.", call. = FALSE)
        if(any(dsel <= 0))            stop("Invalid Input for dsel: Only positive integers allowed.", call. = FALSE)
        if(any(dsel > length(dlist))) stop(paste0("Invalid Input: dsel ",dsel," exceeds total number of dimensions (",length(dlist),")"))
        
        dlist_sel_dim = dlist[dsel]
#        isel = unlist(lapply(sapply(dlist_sel_dim,"[","thresholds"),colnames))
        
      } # end of if input was numeric
      
    } # end if/else dimension selection
    
    # --- 2. Select items (selection string character)

    if(is.null(isel)){

       dlist_sel_itm = dlist_sel_dim  # no item selection: is.null(isel)
       isel = unlist(lapply(sapply(dlist_sel_dim,"[","thresholds"),colnames))

    } else {  # execute isels

      dlist_sel_itm = vector(mode="list", length=length(dlist_sel_dim)) 
      names(dlist_sel_itm) = names(dlist_sel_dim)
      
      if(anyNA(isel) != 0)        stop("Invalid Input for isel! Missing values (NA) are not accepted." )
      if(anyDuplicated(isel)!= 0) stop("Invalid Input for isel! Same Items were selected multiple times.")
      if(is.numeric(isel)) isel = ilab[isel]    # convert numeric indices to label strings

      for(d in seq_along(dlist_sel_dim)){

          i_lab = colnames(dlist_sel_dim[[d]]$thresholds)
          isitm = i_lab %in% isel

          if (sum(isitm)==0) {
               warning(paste0("\nItem '", isel[!(isel %in% i_lab)], "' not found in dimension ", d, " (", dlab[d], ")." ), call. = FALSE)
               dlist_sel_itm[[d]] = NA  # not NULL here -- loop counter d!
          }else{
               dlist_sel_itm[[d]]$thresholds     = dlist_sel_dim[[d]]$thresholds    [,isitm, drop=FALSE]
               dlist_sel_itm[[d]]$discrimination = dlist_sel_dim[[d]]$discrimination[,isitm, drop=FALSE]
               dlist_sel_itm[[d]]$guessing       = dlist_sel_dim[[d]]$guessing      [ isitm ]
               dlist_sel_itm[[d]]$laziness       = dlist_sel_dim[[d]]$laziness      [ isitm ]
               dlist_sel_itm[[d]]$model          = dlist_sel_dim[[d]]$model         [ isitm ]
               dlist_sel_itm[[d]]$person_par     = dlist_sel_dim[[d]]$person_par
               
               dlist_sel_itm[[d]]$SE_par$se.thresholds     = dlist_sel_dim[[d]]$SE_par$se.thresholds    [ isitm, , drop=FALSE]
               dlist_sel_itm[[d]]$SE_par$se.discrimination = dlist_sel_dim[[d]]$SE_par$se.discrimination[,isitm, drop=FALSE]
               dlist_sel_itm[[d]]$SE_par$se.guessing       = dlist_sel_dim[[d]]$SE_par$se.guessing[ isitm ]
               dlist_sel_itm[[d]]$SE_par$se.laziness       = dlist_sel_dim[[d]]$SE_par$se.laziness[ isitm ]
                 
          }# end of if/else isitm valid
          
          

      } # for d

    } # end if/else isel=NULL

  } # end of if/else all _sel=NULL
  

  dlist_sel_itm[is.na(dlist_sel_itm)] = NULL # eliminate unused dims
  freq_sel = freq[isel]
  data = data[,isel,drop=FALSE]

  # --- sorting
  ks = unlist(lapply(lapply(dlist_sel_itm,"[[","thresholds"),ncol)) # items/dim
  sortvec = 1:sum(ks)
  sortopt = c("mean","median","var","min","max","range","disc","guess","lazy", "none")
  sorterr = paste0("Invalid sorting option '",how_sort,"'.\n  Use one out of: ",paste(sortopt,collapse="/"),".\n  No sorting will be performed.")

  if (length(how_sort) == 1 & how_sort != "none") { # any sorting wishes?

      if (how_sort %in% sortopt) {
           D0 = length(dlist_sel_itm)

           if(tot_sort){ # over all dimensions (total sort) ?

                tx = NULL
                dx = NULL
                gx = NULL
                lx = NULL
                for(d in 1:D0) {
                    tx = cbind(tx,dlist_sel_itm[[d]]$thresholds)
                    dx = cbind(dx,dlist_sel_itm[[d]]$discrimination)
                    gx =     c(gx,dlist_sel_itm[[d]]$guessing)
                    lx =     c(lx,dlist_sel_itm[[d]]$laziness)
                } # end for d
                sortvec = switch(how_sort,
                                 "mean"   = rank(colMeans(tx         ,na.rm=TRUE),ties.method="first"),
                                 "median" = rank(   apply(tx,2,median,na.rm=TRUE),ties.method="first"),
                                 "var"    = rank(   apply(tx,2,var   ,na.rm=TRUE),ties.method="first"),
                                 "min"    = rank(   apply(tx,2,min   ,na.rm=TRUE),ties.method="first"),
                                 "max"    = rank(   apply(tx,2,max   ,na.rm=TRUE),ties.method="first"),
                                 "range"  = rank(   apply(tx,2,drange,na.rm=TRUE),ties.method="first"),
                                 "disc"   = rank(colMeans(dx         ,na.rm=TRUE),ties.method="first"),
                                 "guess"  = rank(         gx                     ,ties.method="first"),
                                 "lazy"   = rank(         lx                     ,ties.method="first")
                                 ) # end switch
           }else {  # sort per dimension

                sortvec = NULL
                kk = c(0,cumsum(ks))
                for (d in 1:D0) {
                     sortmodel = unique(dlist_sel_itm[[d]]$model)
                     if (length(sortmodel) > 1) {

                       warning(paste0("Mixed model types currently not supported (",sortmodel,"). No sorting will be performed for dimension",d,".\n"))

                     } else { # only items of the same type present

                       if (how_sort=="disc"  & length(unique(as.vector(dlist_sel_itm[[d]]$discrimination)))==1)             message(       "Note: Sorting by discrimination parameter has no effect if all items have equal discrimination parameter values.\n")
                       if (how_sort=="guess" & length(unique(as.vector(dlist_sel_itm[[d]]$guessing)))==1)                   message(       "Note: Sorting by guessing parameter has no effect if all items have equal guessing parameter values.\n")
                       if (how_sort=="lazy"  & length(unique(as.vector(dlist_sel_itm[[d]]$laziness)))==1)                   message(       "Note: Sorting by laziness parameter has no effect if all items have equal laziness parameter values.\n")
                       if (sortmodel %in% c("Rasch","2PL","3PL","3PLu","4PL") & how_sort %in% c("var","min","max","range")) message(paste0("Note: Sorting by variance, min, max, and range will have no effect for model ",sortmodel,".\n"))

                       # TODO: adapt model names for eRm, ltm, psychotools, TAM

                       if (how_sort=="mean" )  sortvec = c(sortvec, kk[d] + rank(colMeans(dlist_sel_itm[[d]]$thresholds         ,na.rm=TRUE),ties.method="first"))
                       if (how_sort=="median") sortvec = c(sortvec, kk[d] + rank(   apply(dlist_sel_itm[[d]]$thresholds,2,median,na.rm=TRUE),ties.method="first"))
                       if (how_sort=="var"  )  sortvec = c(sortvec, kk[d] + rank(   apply(dlist_sel_itm[[d]]$thresholds,2,var   ,na.rm=TRUE),ties.method="first"))
                       if (how_sort=="min"  )  sortvec = c(sortvec, kk[d] + rank(   apply(dlist_sel_itm[[d]]$thresholds,2,min   ,na.rm=TRUE),ties.method="first"))
                       if (how_sort=="max"  )  sortvec = c(sortvec, kk[d] + rank(   apply(dlist_sel_itm[[d]]$thresholds,2,max   ,na.rm=TRUE),ties.method="first"))
                       if (how_sort=="range")  sortvec = c(sortvec, kk[d] + rank(   apply(dlist_sel_itm[[d]]$thresholds,2,drange,na.rm=TRUE),ties.method="first"))
                       if (how_sort=="disc" )  sortvec = c(sortvec, kk[d] + rank(colMeans(dlist_sel_itm[[d]]$discrimination     ,na.rm=TRUE),ties.method="first"))
                       if (how_sort=="guess")  sortvec = c(sortvec, kk[d] + rank(         dlist_sel_itm[[d]]$guessing                       ,ties.method="first"))
                       if (how_sort=="lazy" )  sortvec = c(sortvec, kk[d] + rank(         dlist_sel_itm[[d]]$laziness                       ,ties.method="first"))

                     } # end else (items of same type)

                       # TODO: GRM/dicho --> error
                       # TODO: NRM/dicho --> no sorting (poly?)
                       # TODO: variance  --> only polytomous!

                       # warning: sort result will not be visible

                } # end for d
           } # ende else (= sort per dim
      }else warning(sorterr) # end valid sort option
  } # end any sorting wishes

  dlist_final = dlist_sel_itm

  # --- calculate iif and prob

  dlist_final[is.na(dlist_final)] = NULL
  D = length(dlist_final)
  
  # --- calculate TIF for all (also not selected) items
  for(d in 1:D){

  # k  = dim(dlist[[d]]$thresholds)[2]      MK 14.04.2024: use dlist_final (not dlist without selection)
    k  = dim(dlist_final[[d]]$thresholds)[2]  # final list with selected items
    kf = dim(dlist[[d]]$thresholds)[2]        # original
    
    test_info     = matrix(NA,nrow=length(theta),ncol=k)
    test_info_all = matrix(NA,nrow=length(theta),ncol=kf)
    check = rep(NA, k) # for csel
    


    dlist_final[[d]]$OBS = calc_obs(X=data, perspar=na.omit(dlist_final[[d]]$person_par), empbins = empbins, empcuts = empcuts)
 
    dlist_final[[d]]$SMOspline = calc_smo(cat_freqlist = dlist_final[[d]]$OBS, sortperspar = attributes(dlist_final[[d]]$OBS)$sort_perspar,
                                    smoothargs=smoothargs, smoothrange=smoothrange, smooth = "spline") 
    
    dlist_final[[d]]$SMOloess  = calc_smo(cat_freqlist = dlist_final[[d]]$OBS, sortperspar = attributes(dlist_final[[d]]$OBS)$sort_perspar,
                                     smoothargs=smoothargs, smoothrange=smoothrange, smooth = "loess") 
    
    
    # --- selected list for sTIF & sSE
    
    for(j in 1:k){
      if      (       dlist_final[[d]]$model[j]        == "nominal")        test_info[,j] = with(dlist_final[[d]], info_nom(diff =thresholds[,j], alpha=discrimination[,j], theta=theta))$iif
      else if (       dlist_final[[d]]$model[j] %in% c("graded","grsmIRT")) test_info[,j] = with(dlist_final[[d]], info_sam(thres=thresholds[,j], alpha=discrimination[,j], theta=theta))$iif
      else if (length(dlist_final[[d]]$thresholds[,j]) == 1)                test_info[,j] = with(dlist_final[[d]], info_4pl(thres=thresholds[,j], alpha=discrimination[,j], theta=theta, gamma=guessing[j], upper=laziness[j]))$iif
      else                                                                  test_info[,j] = with(dlist_final[[d]], info_mas(thres=thresholds[,j], alpha=discrimination[,j], theta=theta, gamma=guessing[j], graded=FALSE))$iif
    } # end of j
    
    # --- original list for TIF & SE
    
    for(j in 1:kf){
      if      (       dlist[[d]]$model[j]        == "nominal")              test_info_all[,j] = with(dlist[[d]], info_nom(diff =thresholds[,j], alpha=discrimination[,j], theta=theta))$iif
      else if (       dlist[[d]]$model[j] %in% c("graded","grsmIRT"))       test_info_all[,j] = with(dlist[[d]], info_sam(thres=thresholds[,j], alpha=discrimination[,j], theta=theta))$iif
      else if (length(dlist[[d]]$thresholds[,j]) == 1)                      test_info_all[,j] = with(dlist[[d]], info_4pl(thres=thresholds[,j], alpha=discrimination[,j], theta=theta, gamma=guessing[j], upper=laziness[j]))$iif
      else                                                                  test_info_all[,j] = with(dlist[[d]], info_mas(thres=thresholds[,j], alpha=discrimination[,j], theta=theta, gamma=guessing[j], graded=FALSE))$iif
    } # end of 

    dlist_final[[d]]$TIF = rowSums(test_info_all)
    dlist_final[[d]]$SE  = sqrt(1/rowSums(test_info_all))
    dlist_final[[d]]$REL = dlist_final[[d]]$TIF /(1 + dlist_final[[d]]$TIF) # OConnor, 2018, p.993, eq.6
    
    dlist_final[[d]]$sTIF = rowSums(test_info)
    dlist_final[[d]]$sSE  = sqrt(1/rowSums(test_info))
    dlist_final[[d]]$sREL = dlist_final[[d]]$sTIF / (1 + dlist_final[[d]]$sTIF)
  } # end of d for all TIF

  for (d in 1:D) {
    
     k = dim(dlist_final[[d]]$thresholds)[2]
     test_info = matrix(NA,nrow=length(theta),ncol=k)
     
      
     for (j in 1:k) {
        if (dlist_final[[d]]$model[j] == "nominal") {

          prob = with(dlist_final[[d]], calc_nom(diff=thresholds[,j], alpha=discrimination[,j], theta=theta))
          dlist_final[[d]]$CCC[[j]] = prob$prob_ccc
          dlist_final[[d]]$TCC[[j]] = prob$prob_tcc

          temp = with(dlist_final[[d]], info_nom(diff=thresholds[,j], alpha=discrimination[,j], theta=theta))
          dlist_final[[d]]$CIF[[j]] = temp$cif
          dlist_final[[d]]$IIF[[j]] = matrix(temp$iif,length(theta),1)
          test_info[,j]             = temp$iif

        } else if (dlist_final[[d]]$model[j]%in% c("graded","grsmIRT")) {
          
          prob = with(dlist_final[[d]], calc_ccc(delta=thresholds[,j], alpha=discrimination[,j], gamma=guessing[j], graded=TRUE, theta=theta))
          dlist_final[[d]]$CCC[[j]] = prob$prob_ccc
          dlist_final[[d]]$TCC[[j]] = prob$prob_tcc
          
          temp = with(dlist_final[[d]], info_sam(thres=thresholds[,j], alpha=discrimination[,j], theta=theta))
          dlist_final[[d]]$CIF[[j]] = temp$cif
          dlist_final[[d]]$IIF[[j]] = matrix(temp$iif,length(theta),1)
          test_info[,j]             = temp$iif
          
        } else if(length(dlist_final[[d]]$thresholds[,j])==1){  # dichotom (for upper and gamma)
          
          prob = with(dlist_final[[d]], calc_ccc(delta=thresholds[,j], alpha=discrimination[,j], gamma=guessing[j], graded=FALSE, theta=theta))
          dlist_final[[d]]$CCC[[j]] = prob$prob_ccc
          dlist_final[[d]]$TCC[[j]] = prob$prob_tcc
          
          temp = with(dlist_final[[d]], info_4pl(thres=thresholds[,j], alpha=discrimination[,j], gamma=guessing[j], upper=laziness[j], theta=theta))
          dlist_final[[d]]$CIF[[j]] = temp$cif
          dlist_final[[d]]$IIF[[j]] = matrix(temp$iif,length(theta),1)
          test_info[,j]             = temp$iif
          
        }else{   # PCM, GPCM
          
          prob = with(dlist_final[[d]], calc_ccc(delta=thresholds[,j], alpha=discrimination[,j], gamma=guessing[j], graded=FALSE, theta=theta))
          dlist_final[[d]]$CCC[[j]] = prob$prob_ccc
          dlist_final[[d]]$TCC[[j]] = prob$prob_tcc
          
          temp = with(dlist_final[[d]], info_mas(thres=thresholds[,j], alpha=discrimination[,j], gamma=guessing[j], graded=FALSE, theta=theta))
          dlist_final[[d]]$CIF[[j]] = temp$cif
          dlist_final[[d]]$IIF[[j]] = matrix(temp$iif,length(theta),1)
          test_info[,j]             = temp$iif
          
        } # end else
       
       # expected total score function (ESC)
       
       dlist_final[[d]]$ESC[[j]] = emp_score(ccc=dlist_final[[d]]$CCC[[j]])
       
       if(!is.null(csel)){
        
         stopifnot(is.numeric(csel))
         if(any(csel<=0)) stop("Invalid csel argument! Please use values >= 1.")
         
         
         iscat = csel > ncol(dlist_final[[d]]$CCC[[j]])   # has the user selected invalid categories (itemwise)
         check[j] = all(iscat)
         
         
         if (length(iscat) == 1){
           if(iscat){
             catsel=1:ncol(dlist_final[[d]]$CCC[[j]])
             warning(paste0("'csel' value is larger than the total numer of categories for item ", j, " on dimension ", d, ". The 'csel' argument will be ignored.\n"), call. = FALSE)
            }else catsel=csel
         } else if(length(iscat)  > 1) {
           catsel = csel[iscat==FALSE]  # if many take only the valid ones
           csel=catsel
         }
         if(length(catsel) == 0){
           catsel = 1:ncol(dlist_final[[d]]$CCC[[j]])
           csel   = 1:ncol(dlist_final[[d]]$CCC[[j]])
           warning(paste0("'csel' values are larger than the total numer of categories for item ", j, " on dimension ", d, ". The 'csel' argument will be ignored.\n"), call. = FALSE)
         } 
         
        if(j==k & all(check)) stop(paste0("Invalid 'csel' argument was defined for all items from dimension ", d, ". PIccc cannot be plotted. You may use 'dsel' to select only valid dimensions. \n"), call. = FALSE)
         
         dlist_final[[d]]$CCC[[j]] = dlist_final[[d]]$CCC[[j]][,catsel, drop=FALSE]
         dlist_final[[d]]$CIF[[j]] = dlist_final[[d]]$CIF[[j]][,catsel, drop=FALSE]
         dlist_final[[d]]$OBS[[j]] = dlist_final[[d]]$OBS[[j]][,catsel, drop=FALSE]  
         
         dlist_final[[d]]$SMOspline[[j]] = dlist_final[[d]]$SMOspline[[j]][,catsel, drop=FALSE]  
         dlist_final[[d]]$SMOloess [[j]] = dlist_final[[d]]$SMOloess [[j]][,catsel, drop=FALSE]  
  
       } # end of csel
  
     } # end for j
     
     dlist_final[[d]]$toalESC = rowSums(do.call(cbind, dlist_final[[d]]$ESC))
      
     nx = colnames(dlist_final[[d]]$thresholds) # paste0("I",1:k)
     names(dlist_final[[d]]$CCC) = nx
     names(dlist_final[[d]]$TCC) = nx
     names(dlist_final[[d]]$CIF) = nx
     names(dlist_final[[d]]$IIF) = nx
     names(dlist_final[[d]]$OBS) = nx  
     names(dlist_final[[d]]$ESC) = nx  
     
     names(dlist_final[[d]]$SMOspline) = nx  
     names(dlist_final[[d]]$SMOloess ) = nx  
     
     

  } # end for d
  
  dlist_final$freq = freq_sel  # mod 23-04-12: freq$freq; 23-06-27
  dlist_final$sortvec = sortvec

  attr(dlist_final,"source") = attr(dlist,"source")
  attr(dlist_final,"pp")     = attr(dlist,"pp")
  attr(dlist_final,"theta")  = theta

  if (debug) message("Leaving cleaner...")

  return(dlist_final)
  
  
} # end cleaner

calc_obs = function(X, perspar, empbins = NULL, empcuts = NULL) {

    # Prepare data and person parameters

    data = as.data.frame(apply(X, 2, function(x) {
        x - min(x)
    }))

    if (!is.null(empbins)) {

        if (is.null(empcuts)) {
            quantiles = quantile(perspar, seq(0, 1, length = empbins + 1))
            # SOLLTEN WIR DAS ROUNDEN? SONST PASSIEREN SO DINGE WIE BEI TAM MIT SCIENCE, DASS DIE CUTS
            # NUR ALS RANGE DEFINIERT WERDEN, WEIL DIE UNTERSCHIEDE IN DEN CUTS ZU GERING SIND
            cuts = cut(perspar, unique(round(quantiles, 5)), include.lowest = TRUE)
            if (sum(duplicated(quantiles)) > 0) {
                warning("Some quantiles were not unique and were therefore combined.", call. = FALSE)
            }
        } else {
            message("Both empcuts and empbins specified, empcuts settings will be used.")
            cuts = cut(perspar, empcuts, include.lowest = TRUE)
        }

        sort_perspar = aggregate(perspar, list(cuts), mean, na.rm = TRUE)[, 2]
        ppar = cuts

    } else if (!is.null(empcuts)) {
        cuts = cut(perspar, empcuts, include.lowest = TRUE)
        sort_perspar = aggregate(perspar, list(cuts), mean, na.rm = TRUE)[, 2]
        ppar = cuts
    } else {
        ppar = perspar
        sort_perspar = aggregate(data + 1, by = list(ppar), sum)[, 1]
    }

    # Calculate frequency of choosing a category given the person parameter

    freq_list = lapply(seq_along(colnames(data)), function(x) {
        cats = max(data[, x], na.rm = TRUE) + 1
        n_cat = aggregate(data[, x] + 1, by = list(ppar), tabulate, nbins = cats)  # data must be zero based
        n_cat = n_cat[-1]  # delete the group vector
        freq_cat = n_cat/rowSums(n_cat)
        colnames(freq_cat) = gsub("x", colnames(data)[x], colnames(freq_cat))
        return(freq_cat)
    })

    names(freq_list) = colnames(data)
    attr(freq_list, "sort_perspar") = sort_perspar
    if (!is.null(empbins) | !is.null(empcuts)) {
        attr(freq_list, "cuts") = cuts
    }
    return(freq_list = freq_list)
}

decider = function(resobj,pp=NULL,debug=TRUE){

  if (debug) message("Entering decider...")

  if (inherits(resobj,c("dRm", "Rm", "eRm"))){
    
    if (!requireNamespace("eRm")) stop("Please install the eRm package.")
    extracted_obj = ext_erm(resobj, pp=pp, debug=debug)
    
  } else if(inherits(resobj,c("rasch", "ltm", "tpm", "gpcm", "grm"))){
    
    if (!requireNamespace("ltm")) stop("Please install the ltm package.")
    extracted_obj = ext_ltm(resobj, pp=pp, debug=debug)
    
  } else if(inherits(resobj,c("raschmodel", "nplmodel", "pcmodel", "rsmodel", "gpcmodel"))){
    
    if (!requireNamespace("psychotools")) stop("Please install the psychotools package.")
    extracted_obj = ext_psy(resobj, pp=pp, debug=debug)
    
  } else if(!is.null(attributes(class(resobj))$package)){
    
    if(attributes(class(resobj))$package == "mirt"){
      if (!requireNamespace("mirt")) stop("Please install the mirt package.")
      extracted_obj = ext_mirt(resobj, pp=pp, debug=debug)
    }
    
  } else if(inherits(resobj,c("tam.mml", "tam.mml.2pl", "tam.mml.3pl"))){

    if (!requireNamespace("TAM")) stop("Please install the TAM package.")
    extracted_obj = ext_tam(resobj, pp=pp, debug=debug)
    
  } else stop("Given result object is not supported by PIccc!")
  
  if (debug) message("Leaving decider...")

  return(extracted_obj)
  
} # end of decider fun

# Calculate CCC and TCC ---------------------------------------------------

  calc_ccc = function(delta, theta=seq(-6,6,0.01), alpha=1, gamma=0, upper=1, graded=FALSE){
    
    dlt = rmNA(delta)
    
    if(length(alpha) == 1) current_alpha = rmNA(rep(alpha, each=length(dlt)))  # Ueberlegung: a,g,u skalar lassen
    else                   current_alpha = alpha
    
    current_gamma = rmNA(rep(gamma, each=length(dlt)))
    current_upper = rmNA(rep(upper, each=length(dlt)))
    
    # --- TCC
    
    prob_tcc = matrix(NA ,nrow=length(theta), ncol=length(dlt))
    for(i in seq_along(dlt)) prob_tcc[,i] = current_gamma[i]+((current_upper[i]-current_gamma[i])*exp( current_alpha[i] * (theta - dlt[i])  )/(1+exp(current_alpha[i] * (theta - dlt[i])  )) )
    
    # --- CCC
    
    if(!graded){
      
      num = matrix(NA ,byrow=TRUE, nrow=length(theta), ncol=length(dlt))                              # numerator calculations
      par_sum = cumsum(dlt)
      
      for(i in 1:length(dlt)) num[ ,i] = exp( current_alpha[i]  * (i * theta - par_sum[i]))
      
      denom = 1 + rowSums(num)
      pp = (num[, 1:length(dlt)]/denom)                                                               # add 0 category
      prob_out = cbind( (1/denom), pp)                                                                # result
      
    }else{
      
      if(length(dlt)==1) prob_out = cbind(1-prob_tcc[,1],prob_tcc[,ncol(prob_tcc)])                   # cbind generates a matrix! :)
      else               {
        
        fst_cat = 1-prob_tcc[,1]
        lst_cat = prob_tcc[,ncol(prob_tcc)]
        if(is.vector(-apply(prob_tcc, 1, diff))) mdd_cts = cbind(-apply(prob_tcc, 1, diff))
        else                                     mdd_cts = t(-apply(prob_tcc, 1, diff))
        
        prob_out = cbind(fst_cat, mdd_cts,lst_cat) # first, middle,last categories
      }
      
    } # end of CCC calculations
    if(any(current_gamma != 0)) prob_out = cbind(1-prob_tcc, prob_tcc)  # CCC perspective P(0) and P(1), 3PL correction 
    return(list(prob_ccc=prob_out, prob_tcc=prob_tcc))
    
  } # end of calc_ccc
  
  
# Probability for NRM -----------------------------------------------------

calc_nom = function(diff, alpha, theta=seq(-6,6,0.1)){ # Bock 1972
  
  d = rmNA(diff)     # difficulty
  a = rmNA(alpha)    # alpha/discrimination
  
  if(length(d) != length(a)) stop("alpha and difficulty lengths differ!")

  z_mat      = matrix(NA, nrow=length(theta), ncol=length(d))
  for(i in 1:ncol(z_mat)) z_mat[,i] = d[i] + a[i]*theta
  z_mat_e    = exp(z_mat)
  denom      = rowSums(z_mat_e)
  cat_mat    = apply(z_mat_e, 2, function(x){x/denom})
  prob_tcc   = calc_ccc(get_intersection(gamma = d, alpha = a), theta = theta, alpha = diff(a))$prob_tcc
  return_obj = list(prob_ccc=cat_mat, prob_tcc=prob_tcc)
  
  return(return_obj)
  
}

# Get Intersection --------------------------------------------------------

get_intersection = function(gamma, alpha){ # de Ayala 1993 (2022)
  
  if(length(gamma) != length(alpha)) stop("Invalid vector length!")
  delta = -diff(gamma)/diff(alpha)
  return(delta)
  
}# end of get_intersection


# informations for 1-4pl --------------------------------------------------

info_4pl = function(thres, theta=seq(-6,6,0.1), alpha=1, gamma=0, upper=1){
  
  prob = calc_ccc(delta=thres, theta=theta, alpha=alpha, gamma=gamma, upper=upper)$prob_tcc
  cats = calc_ccc(delta=thres, theta=theta, alpha=alpha, gamma=gamma, upper=upper)$prob_ccc
  
  iif  = (alpha^2*(prob-gamma)^2*(upper-prob)^2)/((upper-gamma)^2*prob*(1-prob))
  cif  = apply(cats, 2, function(x) x*iif)
  
  return(list(cif=cif, iif=iif))
} # end of fun

# IIF Masters Formulation -------------------------------------------------

info_mas = function(thres, theta=seq(-6,6,0.1), alpha=1, gamma=0, graded=FALSE){

  cat_prob = calc_ccc(delta=thres, theta=theta, alpha=alpha, gamma=gamma, graded=graded)$prob_ccc

  k = 1:ncol(cat_prob)
  
  info = (alpha)^2 * (rowSums(sweep(cat_prob, 2, k^2, '*')) - rowSums(sweep(cat_prob, 2, k, '*'))^2)
  cif_mat = cat_prob*info
  
  return(list(cif=cif_mat, iif=rowSums(cif_mat)))
  
} # end of info_Masters

# IIF Samejimas Formulation -----------------------------------------------

info_sam = function(thres, theta=seq(-6,6,0.1), alpha=1){
  
  t = rmNA(thres)
  a = rmNA(alpha)
  
  tcc_prob = calc_ccc(delta=t, theta=theta, alpha=alpha)$prob_tcc                 # prob
  first_deriv=matrix(NA, nrow=length(theta), ncol=ncol(tcc_prob))                 # prepare matrix for derivatives
  for(i in 1:ncol(first_deriv)) first_deriv[,i]=tcc_prob[,i]*(1-tcc_prob)[,i]     # calc derivative (conditional variance)
  
  num_cat0 = (-first_deriv[,1])                                                   # create numerator
  num      = matrix(NA, nrow=length(theta), ncol=(ncol(first_deriv)-1))
  for(i in 1:ncol(num)) num[,i] = (first_deriv[,i]-first_deriv[,i+1])
  num_last = first_deriv[,ncol(first_deriv)]
  num_mat  = cbind(num_cat0, num, num_last)^2
  
  ccc_prob = calc_ccc(delta=t, theta=theta, alpha=alpha, graded=TRUE)$prob_ccc
  
  cif_share = matrix(NA, nrow=length(theta), ncol=ncol(ccc_prob))
  for(i in 1:ncol(ccc_prob))cif_share[,i] = (alpha)^2*(num_mat[,i]/(ccc_prob[,i]))
  
  return(list(cif=cif_share, iif=rowSums(cif_share)))
  
} # end of info_Samejima

# IIF for NRM -------------------------------------------------------------

info_nom = function(diff, alpha, theta=seq(-6,6,0.1)){
 
  d = rmNA(diff)     # difficulty
  a = rmNA(alpha)    # alpha/discrimination
  
  iif  = rep(NA, length(theta))
  
  for(i in seq_along(theta)){
    
      P       =  calc_nom(diff = d, alpha = a, theta = theta[i])  # get prob only for one theta
      W       =  outer(-P$prob_ccc, P$prob_ccc)                   # calculate W matrix
      diag(W) =  P$prob_ccc*(1-P$prob_ccc)
      iif[i]  =  t(a) %*% W %*% a
   
  } # end of for loop
  
  prob = calc_nom(diff=d, alpha=a, theta=theta)$prob_ccc
  return(list(cif=prob*iif, iif=iif))

  
} # end of info_nom


# # empirical CCCs Davide ---------------------------------------------------
# 
#   calc_obs = function (data,perspar, ngroups = NULL) {
# 
#     cats = range(data, na.rm = TRUE)[2]+1   # why range()[2], not max()?
#     n_cat = aggregate(data+1, by = list(perspar), tabulate, nbins = cats)  # data must be zero based
#     n_cat = n_cat[-1]
#     prop_list = list()
# 
#     for (isl in 1:NCOL(data)) {
#          prop_cat = n_cat[isl]/rowSums(n_cat[isl])
#          prop_list[[isl]] = prop_cat
#     } # end for
# 
#     sort_perspar = sort(unique(perspar))
# 
#     if (!is.null(ngroups)) {
#       quantiles = quantile(perspar, seq(0, 1, length = ngroups+1))
#       cuts = cut(perspar, unique(quantiles),  include.lowest = TRUE)
#       n_cat = aggregate(data+1, by = list(cuts), tabulate, nbins = cats)
#       n_cat = n_cat[-1]
#       prop_list = list()
#       attr(prop_list, "cuts") = cuts
# 
#       for (isl in 1:NCOL(data)) {
#            prop_cat = n_cat[isl]/rowSums(n_cat[isl])
#            prop_list[[isl]] = as.matrix(prop_cat)
#       }
#       sort_perspar =  aggregate(perspar, list(cuts), mean, na.rm = TRUE)[, 2]
# 
#       if (sum(duplicated(quantiles)) > 0) {
#         warning("Some Quantiles were not unique and were therefore combined.", call. = FALSE)
#       } # end if
# 
#     } # not is.null(ngroups)
#     attr(prop_list, "sort_perspar") = sort_perspar
#     return(prop_list)
#   }  
#   

# Empirical Score Function ------------------------------------------------

  emp_score = function(ccc){
    k = ncol(ccc)-1
    e = matrix(NA, nrow=nrow(ccc), ncol=ncol(ccc))
    for(i in 0:k) e[,i+1] = i * ccc[,i+1] # 0!!!
    es = cbind(rowSums(e))
    return(es)
  } # end of emp_score
  

# Helper Functions --------------------------------------------------------

is.int = function(x) floor(x) == x

# ---

rmNA = function(x){
  if(sum(is.na(x)) == 0) return(x)
  else                   return(x[-which(is.na(x))])
}

ext_psy = function(resobj, pp=NULL, debug=TRUE){
  
  if (debug) message("Entering psychotools-extractor...")

  tt = psychotools::threshpar(resobj)
  inum = length(tt)
  ncat = sapply(tt, length)
  mseq = seq_len(max(ncat))
  
  if (is.character(pp) && pp=="auto") {
     pp = psychotools::personpar(resobj, personwise=TRUE)
  } else if (!is.null(attr(pp,"pp"))) {
         pp = attr(pp,"pp")
         stopifnot("Please use the result object from psychotools::personpar()." = inherits(pp,"personpar"))
  } else if (is.character(pp) && pp != "skip") {                       # 'skip' for RMX::RMD!
         stopifnot("Please use the result object from psychotools::personpar()." = inherits(pp,"personpar"))
  }
  
  # PREP for SE_par now only empty container summary(resobj)$coefficients[,2]
  
  se.thresholds = t(matrix(NA, dim(rbind(sapply(tt, "[", i = mseq)))[1], dim(rbind(sapply(tt, "[", i = mseq)))[2]))
  se.discrimination = rbind(rep(NA, inum))
  se.guessing = rbind(rep(NA, inum))
  se.laziness = rbind(rep(NA, inum))

  dims_list = vector(mode="list", length=1)
  names(dims_list) = "F1"
  dims_list[[1]]$thresholds     = rbind(sapply(tt, "[", i = mseq))
  dims_list[[1]]$discrimination = rbind(psychotools::discrpar(resobj))
  dims_list[[1]]$guessing       =       psychotools::guesspar(resobj)
  dims_list[[1]]$laziness       =       psychotools::upperpar(resobj)
  dims_list[[1]]$model          = rep(attributes(tt)$model, inum)
  dims_list[[1]]$person_par     = pp #[!is.na(pp)]
  dims_list[[1]]$SE_par         = list(se.thresholds=se.thresholds,
                                       se.discrimination=se.discrimination,
                                       se.guessing=se.guessing,
                                       se.laziness=se.laziness)
  
  
  
  colnames(dims_list[[1]]$thresholds) = colnames(dims_list[[1]]$discrimination)
  
  dims_list$freq = apply(resobj$data,2,table,simplify=FALSE)
  data = resobj$data

  attr(dims_list,"source") = paste0("psy/",attributes(tt)$model)
  attr(dims_list,"pp")     = pp
  attr(dims_list,"data")   = data
  
  if (debug) message("Leaving psychotools-extractor...")

  return(dims_list)
} # end of ext_psy

ext_ltm = function(resobj, pp=NULL, debug=TRUE){

  if (debug) message("Entering ltm-extractor...")

  D=1
  parmat = coef(resobj)

  if (is.list(parmat)) {                                   # if unequal cats/item (PCM/GPCM)
      cmax = max(sapply(parmat,length))                    # max no. of pars/item
      atmp = sapply(parmat,function(x) x[length(x)])       # last is alpha
      ctmp = lapply(parmat,function(x) c(x[1:(length(x)-1)],rep(NA,cmax-length(x)))) # others are thresholds
      parmat = t(rbind(as.data.frame(ctmp),alpha=atmp))
  }

  guessing = rep(0, nrow(parmat))
  laziness = rep(1, nrow(parmat))
  
  if(inherits(resobj,"rasch")){
    
     if(all(parmat[,2] == 1)) model = rep("Rasch", nrow(parmat))
     else                     model = rep("2PL",   nrow(parmat))  # 1PL explained in the BA docu
     
     tt = rbind(parmat[,1])   # thresholds
     dd = rbind(parmat[,2])   # discriminations
     
     #se = ltm::summary.rasch(resobj)$coefficients[,2] # standard errors for thresholds
     
  }else if(inherits(resobj,"ltm")){
    
     if(ncol(parmat)==3) D=2
     model = rep("2PL", nrow(parmat))
     
     tt = rbind(parmat[,1])
     dd = rbind(parmat[,2:ncol(parmat)])
     
     #se = ltm::summary.ltm(resobj)$coefficients[,2]
     
  }else if(inherits(resobj,"gpcm")){
    
     dd = rbind(parmat[,ncol(parmat)])
     if(all(dd == 1)) model = rep("PCM",  nrow(parmat))
     else             model = rep("gpcm", nrow(parmat))
     tt = t(parmat[,-ncol(parmat)])      # 23-04-12: changed from -parmat
     
     #se = do.call(cbind, lapply(ltm::summary.gpcm(resobj)$coefficients, "[", ,2)) 
     
  }else if(inherits(resobj,"grm")){
    
     model = rep("graded",nrow(parmat))
     dd = rbind(parmat[, ncol(parmat)])
     tt =     t(parmat[,-ncol(parmat)])
     
     #se = do.call(cbind, lapply(ltm::summary.grm(resobj)$coefficients, "[", ,2)) 
     
  }else  if(inherits(resobj,"tpm")){
    
     model = rep("3PL", nrow(parmat))
     guessing = parmat[,1]
     tt = rbind(parmat[,2])
     dd = rbind(parmat[,ncol(parmat)])
     
     #se = ltm::summary.tpm(resobj)$coefficients[,2]
     
  }else stop(paste("Unknown class of input object:",class(resobj)))
  
  dims_list = vector(mode="list", length=D)
  names(dims_list) = paste0("F", 1:D)

  if (is.character(pp) && pp=="auto") {
         pp=ltm::factor.scores(resobj, resp.patterns=resobj$X)
  } else if (!is.null(attr(pp,"pp"))) {
         pp = attr(pp,"pp")
         stopifnot("Please use the result object from ltm::factor.scores()." = inherits(pp,"fscores"))
  } else if (is.character(pp) && pp != "skip") {                       # 'skip' for RMX::RMD!
         stopifnot("Please use the result object from ltm::factor.scores()." = inherits(pp,"fscores"))
  }



  pnam = paste0("z", 1:D)
  if (is.list(pp)) {
      pp_only = pp$score.dat[,pnam,drop=FALSE]  # not 'skip'! 2024-04-17
  } else {
      pp_only = rbind(rep("skip",D))
  }
  
  if(resobj$IRT.param) TT = tt
  else{
    for (d in 1:D) TT = -t(t(tt)/dd[,d])   # 23-04-12: -tt
    if(inherits(resobj,"grm")) TT = -TT    # GRM is special...
  }
  
  se.thresholds = t(matrix(NA, dim(TT)[1], dim(TT)[2]))
  se.discrimination = rep(NA, ncol(TT))
  se.guessing = rep(NA, ncol(TT))
  se.laziness = rep(NA, ncol(TT))

  for(d in 1:D){
      dims_list[[d]]$thresholds       = TT
      dims_list[[d]]$discrimination   = dd[d,,drop=FALSE]
      dims_list[[d]]$guessing         = guessing
      dims_list[[d]]$laziness         = laziness
      dims_list[[d]]$model            = model
      dims_list[[d]]$person_par       = pp_only[,d]
      dims_list[[d]]$SE_par           = list(se.thresholds=se.thresholds,
                                             se.discrimination=se.discrimination,
                                             se.guessing=se.guessing,
                                             se.laziness=se.laziness)
  } # end for d

  data = resobj$X
  attr(dims_list,"source") = paste0("ltm/",model[1])
  attr(dims_list,"pp")     = pp
  attr(dims_list,"data")   = data

  dims_list$freq = apply(resobj$X,2,table,simplify=FALSE)

  if (debug) message("Leaving ltm-extractor...")

  return(dims_list)
  
}

  flexbar = function(dat,
                     col,
                     type=c("freq","raw","indiv"),   # dat is freq count or raw
                     ox = 0.5,                       # offset x (diagram left)
                     oy = 0.5,                       # offset y (diagram bottom)
                     dw = 4,                         # diagram width
                     dh = 3,                         # diagram height
                     im = 0.1,                       # inner margin (%)
                     bd = 0.05,                      # distance between bars
                     bo = 2,                         # bar borders width (NA=no border)
                     w0 = dw*(1-2*im),               # effective witdh of baseline
                     bg = rgb(0.7,0.7,0.8),          # background color
                     pf = TRUE,                      # print abs+rel freq & cats?
                     rf = FALSE,                     # relative frequencies?
                     na = c("no","ifany", "always"), # NA handling (table!)
                     debug=TRUE,
                     ...) {

            if (debug) message("Entering flexbar...")

            count = function(x,useNA,bins=20) {
                    xmin = min(x,na.rm=TRUE)
                    xmax = max(x,na.rm=TRUE)
                    xseq = seq(xmin,xmax,length.out=bins)
                    xfrq = table(cut(x,xseq))
            } # end fun count

            if (!is.table(dat)) {
                str(dat)
                stop("Frequency table required.")
            } # end if not table


            if (sum(c(TRUE,"yes") %in% na) > 0) na = "ifany"

                 if (type[1]=="freq")  t=dat
            else if (type[1]=="raw")   t=table(dat,useNA=na)
            else if (type[1]=="indiv") t=count(dat,useNA=na)
            else stop("Invalid type for flexbar!")

            f = as.numeric(t)
            n = sum(f)
            c = dimnames(t)$dat
            k = length(t)

            if (NA %in% c) c[which(is.na(c))] = "NA"
            if (rf) fx=paste(round(100*f/n,1),"%")
            if (missing(col)) col = 1:k+1

            bw = (w0 - bd*(k+1)) / k                 # bar width
            x0 = ox + im*dw + bd + 0:(k-1)*(bw+bd)   # bars left limits
            x1 = x0 + bw                             # bars right limits
            y0 = oy + dh*im                          # bars baseline

            unit = (dh/max(f))*(1-3*im)              # height unit
            bh = unit*f                              # bar heights
            bm = x0 + bw/2                           # bar midpoints

            rect(ox,oy,ox+dw,oy+dh,col=bg,border=NA) # background box
            segments(ox+im*dw,y0,ox+(1-im)*dw,y0,...)# bottom axis (x)
            rect(x0,y0,x1,y0+bh,lwd=bo,col=col,...)  # bars
            if (pf) {
#               text(bm,y0   ,c ,adj=c(0.5, 1.5),font=2,cex=0.8,...)
                text(bm,y0+bh,f ,adj=c(0.5,-0.5),font=2,cex=0.7,...)
        if (rf) text(bm,y0+bh,fx,adj=c(0.5, 1.5),font=3,cex=0.6,...)
#               text(ox+dw*0.05,ox+dh*(1-0.05),paste("n =",n),font=2,cex=1.1,adj=c(0,1))
            }

            res = list(midpoints=bm,x0=x0,y0=y0,x1=x1,y1=y0+bh,freq=f,relfreq=f/n)

            if (debug) message("Leaving flexbar...")

            return(invisible(res))

  } # end fun flexbar

  

ext_erm = function(resobj, pp=NULL, debug=TRUE){

  if (debug) message("Entering eRm-extractor...")

       if (length(grep("RM" ,resobj$call))>0) model="RM"
  else if (length(grep("RSM",resobj$call))>0) model="RSM"
  else if (length(grep("PCM",resobj$call))>0) model="PCM"
  else stop("Only RM/PCM/RSM supported for the eRm package.")

    # try: resobj$model ?

  if (is.character(pp) && pp=="auto") {
         pp = eRm::person.parameter(resobj)             # get person parameter from eRm
  } else if (!is.null(attr(pp,"pp"))) {
         pp = attr(pp,"pp")
         stopifnot("Please use the result object from eRm::person.parameter()." = inherits(pp,"ppar"))
  } else if (is.character(pp) && pp != "skip") {                       # 'skip' for RMX::RMD!
         stopifnot("Please use the result object from eRm::person.parameter()." = inherits(pp,"ppar"))
  }

  if (model == "RM") {
      thrsh         = rbind(-resobj$betapar)
      se.thresholds = rbind( resobj$se.beta)
  } else {
      thrsh = t(eRm::thresholds(resobj)$threshtable[[1]][,-1])
      ttt = apply(!is.na(thrsh), 2, sum)  # no. of thresholds per item
      k   = length(ttt)
      m   = max(ttt)
      jjj = rep(1:k,ttt)
      ssl = split(eRm::thresholds(resobj)$se.thresh,jjj)
      ssl = lapply(ssl,"length<-",m)
      se.thresholds = matrix(unlist(ssl),k,m, dimnames = list(names(ttt), paste0("t", 1:m, ".se")))
  }
  
  se.discrimination = rbind(rep(NA, ncol(thrsh))) # not applicable in eRm
  se.guessing       = rbind(rep(NA, ncol(thrsh)))
  se.laziness       = rbind(rep(NA, ncol(thrsh)))

  rownames(thrsh) = paste0("T", 1:nrow(thrsh))
  dims_list = vector(mode="list", length=1)        # final list
  names(dims_list) <- "F1"
  model = rep(model, ncol(thrsh))                  # special distinction for PCM/RSM
  dims_list[[1]]$thresholds =      thrsh
  dims_list[[1]]$discrimination =  rbind(rep(1, ncol(thrsh)))
  dims_list[[1]]$guessing =        rep(0, ncol(thrsh))
  dims_list[[1]]$laziness =        rep(1, ncol(thrsh))
  dims_list[[1]]$model =           model
  dims_list[[1]]$SE_par =          list(se.thresholds=se.thresholds,
                                        se.discrimination=se.discrimination,
                                        se.guessing=se.guessing,
                                        se.laziness=se.laziness)
  if (is.list(pp)) {
      px = pp$theta.table[,1]                        # 2024-08-27 RWA
      names(px) = rownames(pp$theta.table)
      dims_list[[1]]$person_par =  px     # was: eRm:::coef.ppar(pp,extrapolated=TRUE)   # 2023-06-25 RWA
  } else {
      dims_list[[1]]$person_par =  "skip" # required for RMD
  }

  data = resobj$X
  dims_list$freq = apply(data,2,table,simplify=FALSE) # requires R > 4.1.0 (*)

  colnames(dims_list[[1]]$thresholds) = names(dims_list$freq) # check erm adds 'beta'
  
  attr(dims_list,"source") = paste0("eRm/",model[1])
  attr(dims_list,"pp")     = pp
  attr(dims_list,"data")   = data

  if (debug) message("Leaving eRm-extractor...")

  return(dims_list)
} # end of ext_erm
  # (*) apply received the simplify option as of 4.1.0

  #  eRm:::coef.ppar:
  #  x <- object$theta.table[, 1]
  #  if (!extrapolated) x[object$theta.table[, 3]] <- NA
  #  names(x) <- rownames(object$theta.table)

calc_smo = function(cat_freqlist,
                    sortperspar,
                    smooth = "spline",
                    smoothargs=NULL,
                    smoothrange = NULL) {

  if(length(smooth) == 0) smooth = "spline"
  if (!is.null(smoothrange)) {
      xaxis = smoothrange
  } else {
      xaxis = seq(min(sortperspar), max(sortperspar), 0.01)
  }

  smooth = tolower(smooth)

  # if (!(smooth %in% c("loess", "spline")))
  #   stop("You provided an unknown option for the smooth argument.
  #       \nThe available options are either 'spline' or 'loess'.", call. = FALSE)

  if (smooth == "loess") {
      smoothlist = lapply(cat_freqlist, function(z) {
         y = as.data.frame(z)
         lapply(y, function(x) {
                   smoothcalc = do.call(loess, c(list(x ~ sortperspar), smoothargs))
                   yaxis = predict(smoothcalc, xaxis)
         })
      })
  } else if (smooth == "spline") {
      smoothlist = lapply(cat_freqlist, function(z) {
         y = as.data.frame(z)
         lapply(y, function(x) {
                   smoothcalc = do.call(smooth.spline, c(list(sortperspar, x), smoothargs))
                   yaxis = predict(smoothcalc, xaxis)$y
      })
    })
  }
  smoothdf = lapply(smoothlist, function(x) {do.call(cbind, x)})
  attr(smoothdf, "xaxis") = xaxis
  return(smoothdf = smoothdf)
}

#' BIG 5 Example Data Set
#'
#' Description: A data set simulated after a students survey of the BIG 5 
#' (Openness [O], Conscienciousness [C], Extraversion [E], Agreeableness [A], 
#' and Neuroticism [N]). The scale comprises 21 items following the structure 
#' of the BFIK (DOI 10.1026/0012-1924.51.4.195).
#' @name big5
#' @docType data
#' @format A data.frame with 1076 rows and 21 columns.
#' @details
#' The items were originally presented in German. Here is
#' a rough translation (untested):
#' \describe{
#' \item{Q1R }{[E] I ... am rather reserved.}
#' \item{Q2R }{[A] I ... tend to criticize others.}
#' \item{Q3  }{[C] I ... complete tasks thoroughly.}
#' \item{Q4  }{[N] I ... get depressed easily, depressed.}
#' \item{Q5  }{[O] I ... am interested in many things.}
#' \item{Q6  }{[E] I ... am enthusiastic and can easily carry others away.}
#' \item{Q7  }{[A] I ... trust others easily, believe in the good in people.}
#' \item{Q8R }{[C] I ... am comfortable, tend to laziness.}
#' \item{Q9R }{[N] I ... am relaxed, do not let stress upset me.}
#' \item{Q10 }{[O] I ... am profound, like to think about things.}
#' \item{Q11R}{[E] I ... am rather the 'quiet type', taciturn.}
#' \item{Q12R}{[A] I ... can act cold and distant.}
#' \item{Q13 }{[C] I ... am efficient and work briskly.}
#' \item{Q14 }{[N] I ... worry a lot.}
#' \item{Q15 }{[O] I ... have an active imagination, am imaginative.}
#' \item{Q16 }{[E] I ... go out of myself, am sociable.}
#' \item{Q17R}{[A] I ... can be brusque and dismissive towards others.}
#' \item{Q18 }{[C] I ... make plans and carry them out.}
#' \item{Q19 }{[N] I ... get nervous and insecure easily.}
#' \item{Q20 }{[O] I ... appreciate artistic and aesthetic impressions.}
#' \item{Q21R}{[O] I ... have little artistic interest.}
#' }
#' The response format of all items was:
#' \itemize{
#' \item very inapplicable 
#' \item rather inapplicable 
#' \item neither-nor 
#' \item rather true  
#' \item very true
#' }
#'@examples
#'  library(RMX)
#'  summary(big5)
 "big5"

#  source("drawitem.r")

drawer = function(cleanobj, 
                  theta=seq(-6,6,0.1), 
                  type="CCC",
                  height=8,
                  width=height*(sqrt(5)-1)/2,
                  funhprop=0.7,
                  funwprop=(sqrt(5)-1)/2,
                  funcol=2:20,
                  funlty=1, 
                  funlwd=2, 
                  infcol="black",
                  infoequal=TRUE,
                  infomax="auto",
                  bg=grey(0.9),
                  pplab="abs", 
                  dcol=grey(.9),
                  classical=FALSE,
                  thrsup=TRUE,
                  thrpch=16,
                  legend=TRUE, 
                  legcex=0.7,
                  leglsp=NULL,
                  legoff=0.1,
                  src=TRUE,
                  disind="*",
                  discol="red",
                  discex=1.5,
                  lmar=2,
                  tmar=0,
                  main=NULL,
                  ylas=ylas,
                  usedimcol=TRUE,
                  dencol="black",
                  tifcol="seagreen4",
                  se_col="firebrick4",
                  gridcol="white",
                  relcol="red",

                  grid=TRUE,
                  dens=TRUE,
                  TIF=TRUE,
                  sTIF=TRUE,
                  SE=TRUE,
                  sSE =TRUE,
                  REL=FALSE,
                  sREL=FALSE,
                  TIFmax="auto",
                  SEmax="auto",

                  showlab=1:3,
                  extwin=TRUE,
                  debug=TRUE,
                  csel=NULL,
                  highlight=NULL,
                  empirical=FALSE,
                  emptype="line",
                  empbins=NULL,
                  empsize=0.8,
                  emplwd=1,
                  emplty=5,
                  emppch=20,
                  skipfun=FALSE,
                  resetpar=TRUE,
                  breaks=NULL
  ){

  if (debug) message("Entering drawer...")

  D = length(cleanobj)-2                                        # no. of dims = all - freq - sort
  I = rep(NA,D)                                                 # no. of items/dim

# Axis  ------------------------------------------------------------------------

  dimnames = names(cleanobj)[-length(names(cleanobj))]
  itmnames = NULL
  itmlabel = NULL
  
  for(d in 1:D) {
      I[d] = ncol(cleanobj[[d]]$thresholds)                    # cumulative count of items per dim
      itmnames = c(itmnames,                    colnames(cleanobj[[d]]$thresholds))
      itmlabel = c(itmlabel, paste(dimnames[d], colnames(cleanobj[[d]]$thresholds), sep="_")) 
  } # end for
  
# disordered thresholds --------------------------------------------------------
  
  isdis = NULL
  for(d in 1:D){
      for(i in 1:ncol(cleanobj[[d]]$thresholds)){
         if(cleanobj[[d]]$model[i] == "nominal") isdis = c(isdis,is.unsorted(cleanobj[[d]]$discrimination[,i],na.rm=TRUE))
         else                                    isdis = c(isdis,is.unsorted(cleanobj[[d]]$thresholds[,i],na.rm=TRUE))
      } # end for i
  } # end for d
  
  dislab = ifelse(isdis, disind, " ")


# diagram coordinates ----------------------------------------------------------

  if(length(type) > 1) P = length(type) else P = I  # no. of plots
  K  = sum(P)                                       # no. items across all dims
  ppzero    =  K*funhprop                           # baseline for pp diagrams

  baselines = (K-1):0*funhprop                      # baselines = seq((K)*funhprop, 0, -funhprop)
  if (length(type)==1) baselines = baselines[cleanobj$sortvec]           # totalsort for 1 diag/many items

  t0 = min(theta)
  t1 = max(theta)
  td = t1-t0
  ml = 0.10*td                                      # left margin
  mr = 0.05*td                                      # right margin
  w0 = t0-ml                                        # left-most point in x-direction
  w1 = (w0+ml+td+mr)                                # vertical splitter fun/freq
  wd = w1-w0
  w2 = w1-wd+wd/funwprop

  xx = ifelse(funwprop==0, 1, funwprop)             # for the purpose of drawing baselines, pretend funwprop=1
  w2 = w1-wd+wd/xx

  ph = (K+D-1) - ppzero                             # person diagrams total hight
  pf = ph/D                                         # moving factor for pp diagrams
  ps = 0.85                                         # scaling factor for pp diagrams
  op = rev(ppzero + 0:(D-1)*pf)                     # baselines of pp-diagrams

  imax = max(unlist(lapply(cleanobj[1:D],"[[","IIF")), na.rm=TRUE)  # max value IIF (for y-axis scaling)
  cmax = max(unlist(lapply(cleanobj[1:D],"[[","CIF")), na.rm=TRUE)  # max value CIF (for y-axis scaling)
  emax = max(unlist(lapply(cleanobj[1:D],"[[","ESC")), na.rm=TRUE)  # max value ESC (for y-axis scaling)
  cnum = max(unlist(lapply(cleanobj$freq,length)))                  # max no. cats (PCM+NRM!), corr. 2024-04-05

  while (length(funcol) < cnum) funcol = rep(funcol,2) # adapt color vector length

# ---------------------------------------------------------- === NEW WINDOW HERE
  if (extwin) {
      dev.new(width=width,height=height,noRStudioGD=TRUE)
      orig.par = par(no.readonly = TRUE)
      orig.pal = palette()

      if (resetpar) {
          on.exit(par(orig.par))
          on.exit(palette(orig.pal),add=TRUE)
      } # end if reset
  } # end if extwin
# ------------------------------------------------------------------------------

  par(mar=c(2,lmar,tmar,0)+0.2)
  
  if(D > 1 & funhprop==1) y1=ppzero
  else                    y1=K+D-1
  
  plot(0:1, 0:1,
       type = "n",
       yaxt = "n",
       xaxs = "i",
       yaxs = "i",
       xlim = c(w0,w2), 
       ylim = c(-0.05,y1),
       ylab = "",
       main=main,
       axes = FALSE)

  if(D==1) ax2lab = itmnames
  else     ax2lab = itmlabel

  if(1 %in% showlab) axis(1,at=round(theta,0),labels=round(theta,0), cex.axis=0.7)
  
 # --- draw person area

  dimcol = dcol

  while (length(dimcol) < D) dimcol = rep(dimcol,2)
  while (length(tifcol) < D) tifcol = rep(tifcol,2)
  while (length(se_col) < D) se_col = rep(se_col,2)
  while (length(relcol) < D) relcol = rep(relcol,2)

  if (funhprop < 1  & funwprop > 0) {

        dimnam = names(cleanobj)[1:D]


        for(d in 1:D) {
          
            drawperson(cleanobj[[d]],
                       pp_offx = t0,  #theta[5], TODO: check!
                       pp_offy = op[d]+pf*ps*0.05,
                       pp_labs = pplab,
                       pp_col  = dimcol[d],
                       pp_nam  = dimnam[d],
                       pp_den  = dens,
                       dd_col  = dencol[d],
                       relcol  = relcol[d],
                       do_tif  = TIF,
                       do_se   = SE,
                       do_rel  = REL,
                       do_stif = sTIF,
                       do_sse  = sSE,
                       do_srel = sREL,
                       do_lab  = showlab,
                       th_min  = t0,
                       th_max  = t1,
                       th_vec  = theta,
                       tifcol  = tifcol[d],
                       se_col  = se_col[d],
                       tifmax  = TIFmax,
                       se_max  = SEmax,
                       dw      = td,
                       dh      = pf*ps, # (K+D-1)*(1-funhprop)/D
                       d0      = w0,
                       wd      = wd,
                       breaks  = breaks,
                       debug   = debug
                       ) # end call drawperson

        } # end for d

  } # end funhprop < 1 & funwprop > 0

  if (funhprop > 0 & funwprop > 0) {

   # --- draw background
    if(bg != "none" & !classical){
      
      rect(rep(t0,length(baselines)),       # xleft
           baselines,                       # ybottom
           rep(t1,length(baselines)),       # xright
           baselines+(funhprop*0.9),        # ytop
           col=bg,
           border = 1)   #### <-- dim color ...................................
      
      # draw baselines (adjusted for bg)
      segments(rep(t0, length(baselines)),  # x0
               baselines,                   # y0
               w2,                          # x1 
               baselines,                   # y1
               col=grey(0.6)
      ) # end segments
      
    } #  end of bg
    

    # rect(rep(t0,length(baselines)),       # xleft
    #      baselines,                       # ybottom
    #      rep(t1,length(baselines)),       # xright
    #      baselines+(funhprop*0.9),        # ytop
    #      col=NULL,
    #      border = 1,
    #      lwd=3)   #### <-- dim color ...................................


    if (empirical){
        if (is.character(empsize) && empsize=="binsize") {
            if (is.null(empbins)) {  # no. of bins specified
                ptab = table(cleanobj[[d]]$person_par)
                size = ptab/max(ptab)
                ecex = 0.5*exp(size)
            } else {                 # cuts for bins specified
                ctab = table(attributes(cleanobj[[d]]$OBS)$cuts)
                size = ctab/max(ctab)
                ecex = 0.5*exp(size)
            } # end  empbins
        } else  ecex = empsize # end empsize=binsize
    }




# ========================================================= 0. classical diagram ================================
  if(classical){
    
      II = c(0, cumsum(I))                  # offset for drawing across dims (see below)
      new_base = baselines+funhprop/2
      
      # check if the model (or single items) are nominal and extract thresholds in one object
      # over all dimensions
      
      is_nom_check = unlist(lapply(cleanobj[1:D],"[[","model")) %in% "nominal"
      
      if(sum(is_nom_check)==0){
        ttmp = do.call(cbind, lapply(cleanobj[1:D],"[[","thresholds"))
      }else{
        ttnm = do.call(cbind, lapply(cleanobj[1:D],"[[","thresholds"))    [,is_nom_check]
        ddnm = do.call(cbind, lapply(cleanobj[1:D],"[[","discrimination"))[,is_nom_check]
        
        ttmp = do.call(cbind, lapply(cleanobj[1:D],"[[","thresholds"))
        for(n in which(is_nom_check)){
          
          temp_inter = get_intersection(gamma=ttnm[,n], alpha=ddnm[,n])
          if(length(temp_inter < nrow(ttmp))) temp_inter = c(temp_inter, rep(NA, nrow(ttmp)-length(temp_inter)))
          ttmp[,n] = temp_inter
        }
      } # end of is_nom_check
      
      arrows(t0, new_base, t1, new_base, angle=90, length=0.1, code=3, col=grey(0.7), lty=ifelse(isdis,3,1))
      for(r in 1:nrow(ttmp)){
        sel = which(ttmp[r,] >= t0 & ttmp[r,] <= t1)
        if(length(sel) > 0){
          lines(ttmp[r,][sel], new_base[sel], type="b", col=funcol[r+1], pch=thrpch)
        }
      }# end of drawing classical 
    
      # for(d in 1:D){
      #     for(i in 1:I[d]){
      #       if(cleanobj[[d]]$model[i] == "nominal") {
      #         ttmp = with(cleanobj[[d]], get_intersection(gamma = thresholds[,i], alpha = discrimination[,i]))
      #       } else {
      #         ttmp = cleanobj[[d]]$thresholds[,i]
      #       } # end if/else nominal
      #       sel = which(ttmp >= t0 & ttmp <= t1)
      #       ii = i + II[d]
      #       if (length(sel) > 0) {
      #           if (usedimcol) colx=dimcol[d] else colx=funcol[sel]
      #           segments(min(ttmp),new_base[ii],max(ttmp),new_base[ii],lty=ifelse(isdis[ii],3,1))
      #           points(ttmp[sel],rep(new_base[ii],length(ttmp[sel])),col=colx, pch=thrpch)
      #           text(  ttmp[sel],rep(new_base[ii],length(ttmp[sel])),sel,adj=c(0.5,-0.5),cex=0.5)
# TODO: lines here?
      #       } # end if length sel > 0
      #     } # end of i
      # } # end of d 

      if(2 %in% showlab) axis(2,at=baselines+funhprop/2,labels=ax2lab, las=ylas, cex.axis=0.7)  # (0.3*funhprop):((K-1)*funhprop)

  }else{
    
    # --- draw item curves
    
    CC = 0
    II = c(0, cumsum(I))          # offset for drawing across dims
    
    if(!is.null(highlight)){
       graycol = rep("gray36", cnum)
       graycol[highlight] = funcol[highlight]
       funcol = graycol
    } # end of if highlight defined

    if(is.null(csel)) funcol_c = funcol
    else              funcol_c = funcol[csel]
    
# ========================================== 1. multiple items / single function ================================
    if (length(type)==1) {

        for (d in 1:D) {
             for (i in 1:I[d]) {
                 
                  ii = i + II[d]

                # --- extract reqested data
                  xmat = NULL
                  if (type == "BIF") {
                    xmat = cbind(
                           cleanobj[[d]] [["CIF"]] [[i]],
                           cleanobj[[d]] [["IIF"]] [[i]]
                    ) # end cbind
                  } else {
                    xmat = cleanobj[[d]] [[type]] [[i]]
           
                  } # end else BIF

                # --- rescale item information functions
                  if (type %in% c("CIF","IIF","BIF")) {
                      if (infomax=="auto")  {
                                                     xmax = max(xmat, na.rm=TRUE)
                      } else if (infomax=="equal") {
                        if (type %in% c("IIF","BIF")) {
                                                     xmax = imax
                        } else if (type=="CIF") {
                                                     xmax = cmax
                        } # end type=IIF/BIF vs. CIF
                      } else {
                                                     xmax = infomax
                      } # end if/else equal
                  } else if (type=="ESC"){
                                                     xmax = emax
                  }else {
                                                     xmax = 1
                  } # end if/else info/prob

                  xmat[xmat>xmax] = NA
                  xmat = 0.9*funhprop * xmat/xmax
                  tics = seq(0,xmax,xmax/5)
                  tpos = 0.9*funhprop * tics/xmax
                  
                  # max for empiricals
                  
                  xemp = attributes(cleanobj[[d]]$OBS)$sort_perspar
                  
                  obsmat = cleanobj[[d]]$OBS[[i]]
                  smospl = cleanobj[[d]]$SMOspline[[i]]
                  smoloe = cleanobj[[d]]$SMOloess[[i]]
                  
                  obsmat[obsmat > 1] = 1
                  smospl[smospl > 1] = 1
                  smoloe[smoloe > 1] = 1
                  
                  obsmat[obsmat < 0] = 0
                  smospl[smospl < 0] = 0
                  smoloe[smoloe < 0] = 0
                  
                  obsmat = 0.9*funhprop*obsmat/xmax
                  smospl = 0.9*funhprop*smospl/xmax
                  smoloe = 0.9*funhprop*smoloe/xmax
                  

                # --- draw grid
                  if(grid){
                      vx = seq(ceiling(t0),floor(t1),1)
                      vy = baselines[ii]
                      hy = baselines[ii] + tpos
                      segments(vx,vy+0.01,vx,vy+0.9*funhprop,col=gridcol)
                      segments(t0,hy     ,t1,hy             ,col=gridcol)
                   }  # end if grid


                # --- draw the requested diagram
                  
                  C = ncol(xmat)
         
                  for(c in 1:C) {
                      if (type=="IIF" | (type=="BIF" & c==C)) {
                                             colx=infcol 
                      }else if (type=="TCC") colx=funcol[c+1]
                       else                  colx=funcol_c[c] 
                       
                       if(any(type=="CCC") & skipfun==TRUE) colx=NA
                       
                      lines(theta, baselines[ii]+xmat[,c], col=colx, lty=funlty, lwd=funlwd)
                      
                      if(type=="CCC"){

                         if (empirical){
#                            points(xemp, baselines[ii]+obsmat[,c]*0.9*funhprop, col=colx, pch=16, cex=ecex)
                             if("points" %in% emptype) lines(xemp, baselines[ii] + obsmat[,c]                                     , type="p", col=funcol_c[c],                         pch=emppch, cex=ecex)
                             if("both"   %in% emptype) lines(xemp, baselines[ii] + obsmat[,c]                                     , type="b", col=funcol_c[c], lwd=emplwd, lty=emplty, pch=emppch, cex=ecex)
                             if("line"   %in% emptype) lines(xemp, baselines[ii] + obsmat[,c]                                     , type="l", col=funcol_c[c], lwd=emplwd, lty=emplty)
                             if("spline" %in% emptype) lines(attributes(cleanobj[[d]]$SMOspline)$xaxis, baselines[ii] + smospl[,c], type="l", col=funcol_c[c], lwd=emplwd, lty=emplty)
                             if("loess"  %in% emptype) lines(attributes(cleanobj[[d]]$SMOloess )$xaxis, baselines[ii] + smoloe[,c], type="l", col=funcol_c[c], lwd=emplwd, lty=emplty)
                         } # end if empirical


          # --- empirical CCCs (MK & DA) --------------------------------------- # temporarily defunct 2024-04-06

       #    if(empirical){
       #      temp = cleanobj[[d]]$EMP[[1]]  # temporary empirical matrix
       #      xemp = attributes(cleanobj[[1]]$EMP)$sort_perspar
       #
       #      if (show.size & is.null(empbins)) {
       #        size = table(cleanobj[[d]]$person_par)/max(table(cleanobj[[d]]$person_par))
       #        ecex = exp(size)*0.5
       #      }else if(show.size & !is.null(empbins)) {
       #        size = table(attributes(cleanobj[[d]]$EMP)$cuts)/max(table(attributes(cleanobj[[d]]$EMP)$cuts))
       #        ecex = exp(size)*0.5
       #      }else ecex=1
       #    }

       #   if(empsize){  # defunct RWA 2025-04-06
       #      if(sum("none" %in% empirical) == 0){
       #         if (empsize & is.null(empbins)) {
       #             size = table(cleanobj[[d]]$person_par)/max(table(cleanobj[[d]]$person_par))
       #             ecex = exp(size)*0.5
       #         }else if(empsize & !is.null(empbins)) {
       #             size = table(attributes(cleanobj[[d]]$OBS)$cuts)/max(table(attributes(cleanobj[[d]]$OBS)$cuts))
       #             ecex = exp(size)*0.5
       #         }else
       #             ecex=1
       #        points(xemp, baselines[ii]+obsmat[,c]*0.9*funhprop, col=colx, pch=16, cex=ecex)
       #      } # empirical==none
       #   }# end if empsize


                      }# end of type CCC

                  } # end for c

                # --- threshold indicators & support lines for CCC
                  if (type=="CCC") {

                      ttmp = cleanobj[[d]]$thresholds[,i]


                      if (cleanobj[[d]]$model[i] == "nominal"){ # calculate intersection points

                          itmp = get_intersection(gamma = ttmp, alpha = cleanobj[[d]]$discrimination[,i])    # intersection temp.
                          thry = calc_nom(diff = ttmp, alpha = cleanobj[[d]]$discrimination[,i], theta=itmp)$prob_ccc

                          if (is.vector(thry)) {                # corr 2024-04-04, thx to Davide
                              thry = thry[1]                    # dichotomous case
                          } else {
                              thry = diag(thry[,-ncol(thry)])   # polytomous case: ncol(thry) = nrow(thry)+1
                          } # end else

                          tsel = which(itmp > t0 & itmp < t1)

                          if (length(tsel) > 0) {
                            if(thrsup) segments(itmp[tsel],    baselines[ii],       itmp[tsel],baselines[ii]+0.9*thry[tsel]*funhprop,lty=5,col=funcol[-1][tsel])
                                       points(  itmp[tsel],rep(baselines[ii],length(itmp[tsel]))                               ,pch=thrpch,col=funcol[-1][tsel],xpd=TRUE)
                          }

                      }else{  # all others (not nominal)

                          thry = calc_ccc(delta=ttmp,theta=ttmp, alpha=cleanobj[[d]]$discrimination[i], graded=cleanobj[[d]]$model[i]=="graded")$prob_ccc

                          if (ncol(thry) > 2) {                 # corrected 2024-04-04, thx to Davide
                              thry = diag(thry[,-ncol(thry)])   # polytomous case: ncol(thry) = nrow(thry)+1
                          } else {
                              thry = thry[1,1]                  # dichotomous case (results in 0.5)
                          } # end else

                          tsel = which(ttmp > t0 & ttmp < t1)
                          if (length(tsel) > 0) {
                              if(thrsup) segments(ttmp[tsel],    baselines[ii],       ttmp[tsel],baselines[ii]+0.9*thry[tsel]*funhprop,lty=5,col=funcol[-1][tsel])
                                         points(  ttmp[tsel],rep(baselines[ii],length(ttmp[tsel]))                               ,pch=thrpch,col=funcol[-1][tsel], xpd=TRUE)
                          } # end if length tsel

                      } # end else (not nominal)

                 } # end if ccc
                 
                # --- threshold indicators & 0.5-line for TCC
                  if (type=="TCC"){
                   
                   ttmp = cleanobj[[d]]$thresholds[,i]
                   
                   if(cleanobj[[d]]$model[i] == "nominal"){
                     
                     itmp = get_intersection(gamma = ttmp, alpha = cleanobj[[d]]$discrimination[,i])
                     tsel = which(itmp > t0 & itmp < t1)
                     
                     if (length(tsel) > 0) {
                       if(thrsup) segments(itmp,    baselines[ii],       itmp,baselines[ii]+0.9*0.5*funhprop,lty=5,col=funcol[-1])
                                  points(  itmp,rep(baselines[ii],length(itmp))                                   ,col=funcol[-1],pch=thrpch,xpd=TRUE)
                     }
                   }else{
                     
                     tsel = which(ttmp > t0 & ttmp < t1)
                     if (length(tsel) > 0) {
                       if(thrsup) segments(ttmp[tsel],    baselines[ii],       ttmp[tsel]  ,baselines[ii]+0.9*0.5*funhprop,lty=5,col=funcol[-1][tsel])
                                  points(  ttmp[tsel],rep(baselines[ii],length(ttmp[tsel])),                        ,pch=thrpch, col=funcol[-1][tsel],xpd=TRUE) # TODO?
                     }
                   } # end of else
                   
                   if(thrsup) segments(t0,baselines[ii]+0.9*0.5*funhprop,t1,baselines[ii]+0.9*0.5*funhprop,lty=5,col=grey(.7)) # horiz. middle line 0.5

                 } # end if tcc

                # --- tickmarks/scale on y-axis per diagram and disorder marks
                  if(3 %in% showlab){
                     segments(w0        , baselines[ii]+tpos,
                              w0+0.01*td, baselines[ii]+tpos)
                     text(    w0+0.02*td, baselines[ii]+tpos,
                              formatC(tics,format="f",width=4,digits=2),cex=0.4,adj=c(-0.3,0.5))
                  }

                # --- disorder indicator
                  text(t1+0.03*td,baselines[ii]+0.9*funhprop,dislab[ii],col=discol,cex=discex)
                   
             } # end for i
       } # end for d
      
     # --- legend (top right area)
       if(funhprop < 1 & funwprop < 1){

         if (legend) {
              legx0 = w1              # max(theta)
              legx1 = w2              # legx0+legw
              legy0 = ppzero          # 2.8
              legy1 = K+D-1           # top margin
              legh  = legy1-legy0     # 1.2
              legw  = legx1-legx0     # 7.4
              linh  = legh/15 * leglsp

              legtxt = switch(type,
                              "CCC" = " Category\n Characteristic\n Curves",
                              "TCC" = " Threshold\n Characteristic\n Curves",
                              "IIF" = " Item Information\n Function",
                              "CIF" = " Category Information\n  Function",
                              "BIF" = " Category + Item\n  Information Function",
                              "ESC" = " Expected Score Function"
              ) # end switch type

              text(legx0,legy1,legtxt,cex=0.7,adj=c(-0.02,1.2),font=2)

              legcat = switch(type,
                              "CCC" = "Category",
                              "TCC" = "Threshold",
                              "IIF" = "Item", # unnoetig
                              "CIF" = "Category",
                              "BIF" = "Category",
                              "ESC" = "Expected Score"
              ) # end switch type
              
             


              if(type=="IIF"){

                     points(legx0+legw*0.15              ,legy1-legoff-(1+4)*linh                   ,col=infcol,pch=15) # c+4
                     text(  legx0+legw*0.25              ,legy1-legoff-(1+4)*linh,"Item Information",cex=legcex,adj=c(0,0.4))

              } else if(type=="BIF"){

                   # Item Information
                     points(legx0+legw*0.15              ,legy1-legoff-(0+4)*linh                   ,col=infcol,pch=15,) # c+4
                     text(  legx0+legw*0.25              ,legy1-legoff-(0+4)*linh,"Item Information",cex=legcex,adj=c(0,0.4))

                     if(is.null(csel)) nshowcat = cnum
                     else              nshowcat = length(funcol_c)

                     if (is.null(csel)) {
                         label = paste(legcat, 1:nshowcat)
                     } else {
                         label = paste(legcat,   csel)
                     }

                   # Categories
                     points(rep(legx0+legw*0.15, nshowcat) ,legy1-legoff-(1:nshowcat+4)*linh, col=funcol_c,pch=15)
                     text(  rep(legx0+legw*0.25, nshowcat) ,legy1-legoff-(1:nshowcat+4)*linh, label,cex=legcex,adj=c(0,0.4))
                     
                     # legend(x=legx0,
                     #        y=legy1,
                     #        legend = label,
                     #        fill = funcol_c,
                     #        cex = 0.7, 
                     #        title = "PIccc: BIF",
                     #        title.font = 2,
                     #        bty="n")

              } else if(type %in% c("CCC","CIF")){

                     if (is.null(csel)) {
                         label    = paste(legcat, 1:cnum)
                         nshowcat = cnum
                     } else {
                         label = paste(legcat,   csel)
                         nshowcat  = length(csel)
                     }

                     points(rep(legx0+legw*0.15, nshowcat)   ,legy1-legoff-(1:nshowcat+4)*linh ,col=funcol_c[1:cnum],pch=15)
                     text(  rep(legx0+legw*0.25, nshowcat)   ,legy1-legoff-(1:nshowcat+4)*linh, label, cex=legcex,adj=c(0,0.4))

              } else if(type=="TCC"){ # type=="TCC"

                     points(rep(legx0+legw*0.15, cnum-1)   ,legy1-legoff-(1:(cnum-1)+4)*linh ,col=funcol[-1],pch=15)
                     text(  rep(legx0+legw*0.25, cnum-1)   ,legy1-legoff-(1:(cnum-1)+4)*linh, paste(legcat,1:(cnum-1)),cex=legcex,adj=c(0,0.4))
                     
              } else if(type=="ESC"){
                  
                  points(legx0+legw*0.15,legy1-legoff-(1+4)*linh,col=funcol,pch=15) 
                  text(  legx0+legw*0.25,legy1-legoff-(1+4)*linh,"Expected Score Function", cex=legcex,adj=c(0,0.4))
                

              } else warning(paste("Unknown type:",type),call.=FALSE)


         } # end if legend

       } # end if funhprop

       if(2 %in% showlab) axis(2,at=baselines+funhprop/2,labels=ax2lab, las=ylas, cex.axis=0.7)  # (0.3*funhprop):((K-1)*funhprop)

    } else {

# =========================================== 2. single item / multiple diagrams ================================

      for (t in 1:length(type)) {
           xmat = NULL
           if (type[t] == "BIF") {
             xmat = cbind(
               cleanobj[[d]] [["CIF"]] [[1]],
               cleanobj[[d]] [["IIF"]] [[1]]
             ) # end cbind
           } else {
             xmat = cleanobj[[d]] [[type[t]]] [[1]]
           } # end else BIF


         # --- rescale item and cat information functions
           if (type[t] %in% c("CIF","IIF","BIF")) {

               if (infomax=="auto")  {
                                              xmax = max(xmat, na.rm=TRUE)
               } else if (infomax=="equal") {

                 if (type[t]=="CIF") {

                     if (any(type %in% c("IIF","BIF"))) {
                                              xmax = imax         # cif & iif
                     } else {
                                              xmax = cmax         # cif only
                     } # end if/else CIF only

                 } else if (type[t] %in% c("IIF","BIF")) {
                                              xmax = imax         # iif only
                 } # end iif

               } else { # end if equal
                                              xmax = infomax      # value
               }
           } else if (type[t]=="ESC"){
                                              xmax = emax
           }else {
                                              xmax = 1            # ccc & tcc
           } # end if/else info

           xmat[xmat>xmax] = NA
           xmat = 0.9*funhprop * xmat/xmax
           tics = seq(0,xmax,xmax/5)
           tpos = 0.9*funhprop * tics/xmax
           
           obsmat = cleanobj[[d]]$OBS[[i]]
           smospl = cleanobj[[d]]$SMOspline[[i]]
           smoloe = cleanobj[[d]]$SMOloess[[i]]
           
           obsmat[obsmat > 1] = 1
           smospl[smospl > 1] = 1
           smoloe[smoloe > 1] = 1
           
           obsmat[obsmat < 0] = 0
           smospl[smospl < 0] = 0
           smoloe[smoloe < 0] = 0
           
           obsmat = 0.9*funhprop*obsmat/xmax
           smospl = 0.9*funhprop*smospl/xmax
           smoloe = 0.9*funhprop*smoloe/xmax

         # --- draw grid
           if(grid){
              vx = seq(ceiling(t0),floor(t1),1)  # todo: adapt step to width...
              vy = baselines[t]
              hy = baselines[t] + tpos
              segments(vx,vy+0.01,vx,vy+0.9*funhprop,col=gridcol,lty=1)
              segments(t0,hy     ,t1,hy             ,col=gridcol,lty=1)
           }  # end if grid

         # --- draw requested lines
           C = ncol(xmat)
           for(c in 1:C) {
               if (type[t]=="IIF" | (type[t]=="BIF" & c==C)) ccc = infcol else ccc=funcol_c[c]  # last entry is inf
               if (type[t]=="TCC")                           ccc = funcol[c+1]
               if (type[t]=="CCC" & skipfun)                 ccc = NA # skipfun trick
               
               lines(theta, baselines[t]+xmat[,c], col=ccc, lty=funlty, lwd=funlwd)

               if(type[t]=="CCC"){
                  if("points" %in% emptype) lines(attributes(cleanobj[[d]]$OBS)$sort_perspar, baselines[t]+obsmat[,c], type="p", col=funcol_c[c],                         pch=emppch, cex=ecex)
                  if("both"   %in% emptype) lines(attributes(cleanobj[[d]]$OBS)$sort_perspar, baselines[t]+obsmat[,c], type="b", col=funcol_c[c], lwd=emplwd, lty=emplty, pch=emppch, cex=ecex)
                  if("line"   %in% emptype) lines(attributes(cleanobj[[d]]$OBS)$sort_perspar, baselines[t]+obsmat[,c], type="l", col=funcol_c[c], lwd=emplwd, lty=emplty)
                  if("spline" %in% emptype) lines(attributes(cleanobj[[d]]$SMOspline)$xaxis,  baselines[t]+smospl[,c], type="l", col=funcol_c[c], lwd=emplwd, lty=emplty)
                  if("loess"  %in% emptype) lines(attributes(cleanobj[[d]]$SMOloess )$xaxis,  baselines[t]+smoloe[,c], type="l", col=funcol_c[c], lwd=emplwd, lty=emplty)
              } # end type CCC
           } # end for c

         # --- disordered indicator
           if (type[t]=="CCC") {

              ttmp = cleanobj[[d]]$thresholds[,1]

              if(cleanobj[[d]]$model[1] == "nominal"){ # intersection points of NRM

                 itmp = get_intersection(gamma = ttmp, alpha = cleanobj[[d]]$discrimination[,1])    # intersection temp.
                 thry = calc_nom(diff = ttmp, alpha = cleanobj[[d]]$discrimination[,1], theta=itmp)$prob_ccc

                 if (is.vector(thry)) {                # corr 2024-04-04, thx to Davide
                     thry = thry[1]                    # dichotomous case
                 } else {
                     thry = diag(thry[,-ncol(thry)])   # polytomous case: ncol(thry) = nrow(thry)+1
                 } # end else

                 tsel = which(itmp > t0 & itmp < t1)

                 if (length(tsel) > 0) {
                     if(thrsup) segments(itmp[tsel],    baselines[t],
                                         itmp[tsel],    baselines[t]+0.9*thry[tsel]*funhprop,lty=5,col=funcol_c[tsel])
                                  points(itmp[tsel],rep(baselines[t],length(itmp[tsel])),xpd=TRUE, col=funcol_c[tsel], pch=thrpch)
                 }
             } else {                                   # intersection points of all other models

               thry = calc_ccc(delta=ttmp,theta=ttmp, alpha=cleanobj[[d]]$discrimination[1], graded=cleanobj[[d]]$model[1]=="graded")$prob_ccc

               if (ncol(thry) > 2) {
                   thry = diag(thry[,-ncol(thry)])   # polytomous case: ncol(thry) = nrow(thry)+1
               } else {
                   thry = thry[1,1]                  # dichotomous case (results in 0.5)
               } # end else

               tsel = which(ttmp > t0 & ttmp < t1)

               if (length(tsel) > 0) {
                   if(thrsup) segments(ttmp[tsel],baselines[t],
                                       ttmp[tsel],baselines[t]+0.9*thry[tsel]*funhprop,lty=5   , col=funcol_c[tsel])
                              points(  ttmp[tsel],rep(baselines[t],length(ttmp[tsel])),xpd=TRUE, col=funcol_c[tsel], pch=thrpch)
               } # end thresholds & thrsup-lines
             } # end if/else nominal


           } # end if ccc

           if (type[t]=="TCC"){
             
              
              ttmp = cleanobj[[d]]$thresholds[,1]

              if(cleanobj[[d]]$model[1] == "nominal"){

                 itmp = get_intersection(gamma = ttmp, alpha = cleanobj[[d]]$discrimination[,1])
                 tsel = which(ttmp > t0 & ttmp < t1)
                 segments(itmp,baselines[t],itmp,baselines[t]+0.9*0.5*funhprop,lty=5,col=funcol_c)
                 points(itmp,rep(baselines[t],length(itmp)),col=funcol_c,xpd=TRUE, pch=thrpch)

              }else{

                 tsel = which(ttmp > t0 & ttmp < t1)
                 if (length(tsel) > 0) {
                     if(thrsup) segments(ttmp[tsel],baselines[t]    ,ttmp[tsel],baselines[t]+0.9*0.5*funhprop,lty=5,col=funcol[-1][tsel])
                                points(  ttmp[tsel],rep(baselines[t],length(ttmp[tsel])),col=funcol[-1][tsel],xpd=TRUE, pch=thrpch)
                 } # end if
             } # end else

             if(thrsup) segments(t0,baselines[t]+0.9*0.5*funhprop,t1,baselines[t]+0.9*0.5*funhprop,lty=5,col=grey(.7)) # horiz. middle line 0.5

           }# end of if TCC

         # --- disorder indicator for TCC and CCC
           if (type[t] %in% c("TCC","CCC")) text(t1+0.03*td,baselines[t]+0.9*funhprop,dislab,col=discol,cex=1.5)



         # --- tickmarks/scale on y-axis per diagram
           if(3 %in% showlab){
              segments(w0    ,baselines[t]+tpos,
                       w0+0.1,baselines[t]+tpos)
              text(    w0+0.2,baselines[t]+tpos,#round(tic,1),cex=0.4,adj=c(-0.3,0.5))
                       formatC(tics,format="f",width=4,digits=2),cex=0.4,adj=c(-0.3,0.5))
           }# end of showlab 3

         # --- legends
           if(funwprop < 1){

             if (legend) {
                 legx0 = w1
                 legx1 = w2              # legx0+legw
                 legy0 = baselines[t]    # 2.8
                 legy1 = legy0+0.95*funhprop     # legy0+legh
                 legh  = legy1-legy0     # 1.2
                 legw  = legx1-legx0     # 7.4
                 linh  = legh/8 * leglsp
                 legtxt = switch(type[t],
                                 "CCC" = " Category Characteristic Curves",
                                 "TCC" = " Threshold Characteristic Curves",
                                 "IIF" = " Item Information\n Function",
                                 "TIF" = " Test Information Function",
                                 "CIF" = " Category Information Function",
                                 "BIF" = " Category + Item Information Function"
                 ) # end switch type

                 legcat = switch(type[t],
                                 "CCC" = "Category",
                                 "TCC" = "Threshold",
                                 "IIF" = "Item",
                                 "TIF" = "Test\nInformation\nFunction",
                                 "CIF" = "Category",
                                 "BIF" = "Category",
                                 "ESC" = "Expected Score Function"
                 ) # end switch type

                 if (type[t] != "IIF") {
                     for (c in 1:C) {
                          ytmp = legy1-c*linh
                          if (ytmp < baselines[t]) message("Legend labels exceed vertical legend space. Reducing legend line spacing (leglsp=) may help.\n")
                          if (type[t] == "BIF" & c==C) {
                              points(legx0+legw*0.15,ytmp,pch=15,col=infcol)
                              text(  legx0+legw*0.25,ytmp,"Item Information",cex=legcex,adj=c(0,0.4))
                          } else if (type[t] == "TCC") {
                              points(legx0+legw*0.15,ytmp,pch=15,col=funcol[c+1])
                              if(cleanobj[[d]]$model == "nominal") thrann = itmp # threshold annotation
                              else                                 thrann = ttmp
                              tlab = paste0(legcat," ",c," (",formatC(thrann[c],format="f",width=4,digits=2),")")
                              text(  legx0+legw*0.25,ytmp,tlab              ,cex=legcex,adj=c(0,0.4))
                          } else {
                            
                            if(length(csel)==1) label = paste(legcat,csel)
                            else                label = paste(legcat,c)
                            
                              points(legx0+legw*0.15,ytmp,pch=15,col=funcol_c[c])
                              text(  legx0+legw*0.25,ytmp,label  ,cex=legcex,adj=c(0,0.4))
                          } # end if/else bif/last cat
                     } # end for c
                 } else {
                     ytmp = legy1-linh
                     points(legx0+legw*0.15,ytmp,pch=15,col=infcol)
                     text(  legx0+legw*0.25,ytmp,legtxt,cex=legcex,adj=c(0,0.4))

                 } # end if/else not IIF
             } # end if legend
          } # end of funwprop check < 1
      } # end for t

      flexbar(cleanobj$freq[[1]],
              ox=w1*1.05,
              oy=ppzero,
              dw=(w2-w1)*0.9,
              dh=pf*0.8, #0.95*funhprop,
              bg="white",
              im=0.05,
              bo=NA,
              col=funcol,
              debug=debug)

      iname = colnames(cleanobj$F1$thresholds)[1]
      text(w1,ppzero+pf*0.9,iname,adj=c(-0.5,0),cex=0.8,font=2)
      if(2 %in% showlab) axis(2,at=baselines+funhprop/2,labels=type, las=ylas, cex.axis=0.8)  # (0.3*funhprop):((K-1)*funhprop)



    } # end else (= mult items/one type)

 } # end of if/else classical

  segments(t0,op,w1,op,col=grey(.8))
  abline(v=w1, col=grey(.6))
  abline(h=ppzero, col=grey(.6))

 } # end funhprop < 1 
  
  
  # flexbars getrennt wegen funwprop
  if(funwprop < 1 & funhprop > 0 & length(type)==1){
    
    # flexbar start and width
    
    if(funwprop==0){
       f0 = w0
       fw = (w1-w0)*0.98
    }else {
       f0 = w1
       fw = (w2-w1)*0.98
    }
    II = c(0, cumsum(I))
     
    for(d in 1:D){
      for(i in 1:I[d]){
        ii = i + II[d]
        flexbar(cleanobj$freq[[itmnames[ii]]],
                ox=f0,
                oy=baselines[ii],
                dw=fw,
                dh=0.9*funhprop,
                # bg="white",
                bg="white",
                im=0.05,
                bo=NA, # no borders
                col=funcol,
                debug=debug)
      }# end for i
    }# end for d
    
    abline(v=w1, col=grey(0.7))
    abline(h=ppzero, col=grey(0.7))
  }# end of funwprop check

# --- add source indicator
  if (src) {
      xxx = par("usr")
      text(xxx[2],ifelse(classical, xxx[3] + 0.2, xxx[3]), paste("RMX:",attr(cleanobj,"source")),cex=0.7,adj=c(1.1,1.5),xpd = TRUE)
  } # end if src
  
  box()

  if (debug) message("Leaving drawer...")

} # end fun drawer

ext_tam = function(resobj, pp=NULL, debug=TRUE){

  if (debug) message("Entering TAM-extractor...")

  if (min(resobj$resp) > 0) warning(paste("Responses must be coded 0..k for TAM.\n  Current code range is",paste(range(resobj$resp,na.rm=TRUE),collapse="-"),"\n  Estimates might be wrong/misleading. Check your data!"))

# ...grepl(".2pl",as.character(resobj$CALL)[1],fixed=TRUE)

  D = dim(resobj$B)[3]
  dims_list = vector(mode="list", length=D) 
  names(dims_list) = paste0("F",1:D)

  if (is.character(pp) && pp=="auto") {
     pp = cbind(resobj$person[,seq(6,ncol(resobj$person),2)]) # TODO specify global pp
  } else {
     #stopifnot(inherits(pp,"..."))
  }


  for(d in 1:D){
    all_alphas = resobj$B[,2,d]
    valid_itm  = all_alphas != 0
    alpha      = all_alphas[valid_itm]
    dd         = rbind(apply(resobj$AXsi_[valid_itm,], 1, diff))
    TT         = sweep(dd, 2, alpha, FUN="/")

#   colnames(TT) = rownames(resobj$item) # upd 2023-07-26: no rownames with 3PL
    colnames(TT) = resobj$item$item[resobj$item[,4+resobj$maxK-1+d] != 0] # extract names for the valid dimension.  2024-04-06

    if(is.null(resobj$guess)) gg = rep(0, ncol(TT))
    else                      gg = resobj$guess
    
    # prep for SE_par (for now only empty container)
    
    se.thresholds = t(matrix(NA, dim(TT)[1], dim(TT)[2])) # resobj$xsi$se.xsi # caution: SE of cumulative intercepts+alpha
    se.discrimination = matrix(NA, 1, length(alpha))
    se.guessing = rep(NA, ncol(TT))
    se.laziness = rep(NA, ncol(TT))
    
    dims_list[[d]]$thresholds     = TT
    dims_list[[d]]$discrimination = rbind(alpha)        # check for NRM
    dims_list[[d]]$guessing       = gg
    dims_list[[d]]$laziness       = rep(1, ncol(TT))
    dims_list[[d]]$model          = rep(resobj$irtmodel, ncol(TT))
    dims_list[[d]]$person_par     = pp[,d]
    dims_list[[d]]$SE_par         = list(se.thresholds=se.thresholds,
                                         se.discrimination=se.discrimination,
                                         se.guessing=se.guessing,
                                         se.laziness=se.laziness)

  } # end for d in D

  dims_list$freq = apply(resobj$resp,2,table,simplify=FALSE)
  data = resobj$resp

  attr(dims_list,"source") = paste0("TAM/",resobj$irtmodel)
  attr(dims_list,"data")   = data

  if (debug) message("Leaving TAM-extractor...")

  return(dims_list)
}# end of ext_tam

# --------------------------------------------------------------- from ?tam.mml:
# Option 'irtmodel':
# For fixed item slopes (in tam.mml) options include
# * PCM (partial credit model),
# * PCM2 (partial credit model with ConQuest parametrization 'item+item*step' and
# * RSM (rating scale model; the ConQuest parametrization 'item+step').
#
# For estimated item slopes (only available in tam.mml.2pl) options are
# * 2PL (all slopes of item categories are estimated; Nominal Item Response Model),
# * GPCM (generalized partial credit model in which every item gets one and only slope parameter per dimension) and
# * 2PL.groups or GPCM.groups (subsets of items get same item slope estimates)
#   and a design matrix E on item slopes in the generalized partial credit model (GPCM.design, see Examples).
#
# Note that item slopes can not be estimated with faceted designs using the function tam.mml.mfr.
# However, it is easy to use pre-specified design matrices and apply some restrictions to tam.mml.2pl (see Example 14, Model 3).

#' RMX Rasch Modeling Extended: A Visualisation Tool for IRT Models
#'
#' Provides a customizable function \code{plotPIccc()}, which draws classical
#' PImaps (Wright-Maps) with various graphical extensions, enabling the user
#' to get a quick and differentiated overview for psychometric analyses.
#'
#' @param resobj     Result object of originating package. Compatible packages
#'                   are \code{eRm}, \code{psychotools}, \code{ltm}, \code{mirt},
#'                   and \code{TAM}. Supported models are 1-4PL Models, RM,
#'                   PCM, RSM, GPCM, GRM, GRSM, and NRM.
#' @param pp         Provide previously calculated person parameter estimates
#'                   (practical if the estimation process is slow). In the
#'                   multidimensional case person parameters need to be provided
#'                   column wise in matrix form, i.e., first column = PP of
#'                   first dimension, ...).
#'                   If "auto" (default) the person parameters are determined
#'                   using the default function of the originating package.
#'                   The special option pp="skip" will omit the entire plot
#'                   and prevent the call to person parameter estimation to
#'                   speed up.
#' @param breaks     Number of breaks for the person parameter histogram
#'                   (adopted from the base R hist function).
#' @param type       The function type to plot. Possible options are:
#'                   \itemize{
#'                   \item CCC, the Category Characteristic Curve (default),
#'                   \item TCC, the Threshold Characteristic Curve,
#'                   \item IIF, the Item Information Function,
#'                   \item CIF, the Category Information Function, and
#'                   \item BIF, both the Category and Item information curves
#'                   \item ESC, the empirical score function.
#'                   } Multiple types may be plotted simultaneously if only one 
#'                   item is selected. (\code{length(isel)==1}).
#'                   
#'@param empirical   Show empirical curves? (boolean, default FALSE)
#'                   Applies only if \code{type=CCC}.
#'@param emptype     Type of empirical ICC. Possible options are:
#'                   \itemize{
#'                   \item \code{points}
#'                   \item \code{line} (default)
#'                   \item \code{both}
#'                   \item \code{spline}
#'                   \item \code{loess}
#'                   \item \code{none}
#'                   }
#'                   Multiple types may be specified.
#'@param empbins     Number of bins used for empirical curves.
#'@param empcuts     Cut points for bins for empirical curves.
#'                   Takes precedence if both empbins and empcuts are specified,
#'                   with a warning.
#'@param empsize     Size of points: Numerical (=cex) or string 'binsize', the
#'                   latter reflecting the size of the bins used for grouping.
#'                   (default: 0.8; if binsize: 0.5*exp(n per bin))
#'@param emplwd      Line width of empirical curves (default: 1)
#'@param emplty      Line type of empirical curves (takes values from plot/lty;
#'                   default: 1)
#'@param emppch      Point character of empirical points (default: 20)
#'@param smoothrange Support of the smoothing function along the theta-axis
#'                   if emptype %in% c("spline","loess").
#'                   If \code{NULL} (default) the chosen interval of theta.
#'@param smoothargs  Arguments to be forwarded to \code{stats::smooth.spline()}
#'@param skipfun     Skip drawing of model-based ICC/CCC. Draws only the
#'                   empirical curve.
#'
#' @param tmin       Minimum of theta range to plot.
#' @param tmax       Maximum of theta range to plot.
#' @param isel       Item selection. Select items either by their index on each
#'                   dimension or by their names. If an item is defined on
#'                   multiple dimensions, all instances will be used.
#' @param ilab       Provide item labels (names) for plotting. Has priority over
#'                   \code{isel}.
#' @param csel       Category selection. Select categories to draw by category
#'                   indices. Only numerical values are allowed.
#'                   This is merely a graphical option and has no effect on
#'                   the calculation of related constructs (IIF or TIF).
#'                   Do not combinde \code{csel} with \code{highlight}.
#' @param plab       Labels of person parameter diagramm:
#'                   \itemize{
#'                   \item \code{abs}: absolute frequencies,
#'                   \item \code{rel}: relative frequencies (in %),
#'                   \item \code{den}: density estimate values,
#'                   \item \code{none}: omit labels (default).
#'                   }
#' @param dsel       Dimension selection. Same principle as for \code{isel}.
#' @param dlab       Provide dimension labels for plotting. See \code{ilab} for
#'                   more information.
#' @param lmar       Left margin (in lines).
#' @param ylas       Specify alignment of the y-axis labels (e.g. \code{ylas=2.}
#'                   for horizontal labels).
#' @param showlab    Vector of options in the range are 0:6:
#'                   0 = show no axis labels,
#'                   1 = show outer x-axis (theta range) labels,
#'                   2 = show outer y-axis (item labels),
#'                   3 = show inner y-axis labels of item function diagrams,
#'                   4 = show y-axis labels of person parameter distribution,
#'                   5 = show y-axis labels of SE and sSE line,
#'                   6 = show y-axis labels of TIF and sTIF line,
#'                   (default: 1:3).
#'
#' @param isort      Sorting way may be specified. Possible options are
#'                   \code{mean}, \code{var}, \code{min},
#'                   \code{max}, \code{range}, \code{disc},
#'                   \code{lazy}, \code{guess}, and \code{none} (default).
#' @param gsort      Global sort. If \code{TRUE} all items will be sorted
#'                   across dimensions. If \code{FALSE} items will be sorted
#'                   within dimensions.
#' @param infomax    Vertical scaling of information curves (i.e., CIF, IIF, and
#'                   BIF). Takes either one of the keywords
#'                   \itemize{
#'                   \item \code{auto} (maximize each plot) or
#'                   \item \code{equal} (same scaling for all visible
#'                   information functions), or
#'                   \item a number indicating the maximum to be shown.
#'                   }
#' @param height     Specify the hight of the diagram window.
#' @param width      Width of the diagram (default: the golden ratio to the height).
#' @param funhprop   Proportions of the horizontal axis to be used for the
#'                   function plots. The value of 1 will show only the
#'                   functions, a value of 0 only the person parameters + legend(s).
#' @param funwprop   Proportion of the vertical axis to be used for the functions.
#'                   A value of 1 will only draw the functions and
#'                   person parameter histograms, and a value of 0 frequency
#'                   barplots.
#' @param main       Title string (e.g., for question wording or scale name).
#'                   If not NULL, the upper margin is set to 2, otherwise 0.

#' @param dimcol     Vector of dimension color for the person parameter histograms.
#' @param dencol     Vector of color for the person parameter density lines.
#' @param funcol     The color for functions and thresholds. Provide color vector
#'                   or one of the predefined color schemes
#'                   \itemize{
#'                   \item \code{Rstandard} (default),
#'                   \item \code{rainbow10} (up to 10 response categories),
#'                   \item \code{warm1} (up to 5 response categories),
#'                   \item \code{cool1} (up to 5 response categories), 
#'                   \item \code{contrast1} (up to 5 response categories) or
#'                   \item \code{colorful1} (up to 5 response categories).
#'                   }
#' @param infcol     Specify a separate color for the item information function
#'                   curve (default: \code{black}).
#' @param tifcol     Color of the test information function (TIF).
#' @param se_col     Color of the standard error function.
#' @param relcol     Color of the relative reliability function.
#' @param bgcol      Background color of function plot areas.
#' @param gridcol    Grid color in function plots.
#' @param usedimcol  Use dimension colors for threshold points (classical only).
#' @param highlight  Numerical vector containing the category numbers to be
#'                   highlighted (the others will be drawn in grey).
#'                   Do not combine \code{highlight} with \code{csel}.

#' @param dens       Draw kernel density estimate of person parameter distribution
#'                   (default: TRUE).
#' @param TIF        Draw test information function (default: TRUE).
#' @param sTIF       Draw test information function of selected items (default: TRUE).
#' @param SE         Draw standard error function (default: TRUE).
#' @param sSE        Draw standard error function of selected items (default: TRUE).
#' @param REL        Draw relative reliability (O'Connor, 2018, p.993, eq.6; default: FALSE).
#' @param sREL       Draw relative reliability of selected items (default: FALSE).
#' @param TIFmax     Maximum of test information function (default: "auto").
#' @param SEmax      Maximum of standard error function (default: "auto").

#' @param funlty     Line type of the functions, see \code{type}.
#' @param funlwd     Line width of the functions.

#' @param disind     Disordering indicator (default: \code{"*"}).
#' @param discol     Color of the threshold disorder indicator (default: "red")
#' @param discex     Size of the threshold disorder indicator (default: 1.5)

#' @param legend     If \code{TRUE} (default) insert legend.
#' @param legoff     Legend offset (vertical) from top margin (default: 0.1)
#' @param legcex     Legend text size.
#' @param leglsp     Legend line spacing.

#' @param thrpch     Set threshold point character (NA to suppress).
#' @param thrsup     If \code{TRUE} (default) plot threshold supporting lines.

#' @param src        If \code{TRUE} write the originating package and the
#'                   estimated model in the bottom right corner.
#' @param grid       If \code{TRUE} (default) draw a grid in the function area.
#' @param classical  If \code{TRUE} plot the classical person-item map.
#' @param plot       Plot the diagram (default: \code{TRUE})
#' @param extwin     (logical) Draw diagram(s) into an external window (for
#'                   better compatibility with RStudio and drawing to an external
#'                   file (pdf, png, ...); default: \code{FALSE}).
#' @param resetpar   Reset graphics parameter (default: \code{TRUE}).
#'                   If \code{FALSE}, the diagram coordinates remain, so that
#'                   further annotations can be made to the diagram (see Details).
#' @param debug      (logical) Print call stack (might help tracking error).
#'
#' @return
#' \code{plotPIccc} returns a nested list containing:
#'       \itemize{
#'       \item one list element per dimension. Named by default \code{F1},
#'             \code{F2}, ..., but can be changed with the \code{dlab=} option.
#'       \item the element \code{freq} with the response frequencies of each
#'             item, and
#'       \item \code{sortvec} with the positions of the items as displayed.
#'       }
#' It further contains the attributes
#'       \itemize{
#'       \item \code{source}, indicating the package used for parameter
#'             estimation and the model,
#'       \item \code{pp}, a matrix with the estimated person parameters
#'             (used for avoiding re-estimation if plotPIccc is repeatedly called),
#'       \item \code{data}, the data set as returned from the originating package
#'       \item \code{theta}, the vector used for the horizontal axis.
#'       }
#'
#'
#' @details
#' See Preston & Reise (2013) for the definition and interpretation of the
#' category boundary discrimination (CBD) and threshold characteristic curves
#' (TCCs) in NRM.
#' See de Ayala (1993) for the definition of the intersections in the NRM.
#' See Samejima (1969) for the definition of the category information curve.
#' For references concerning the supported models see the originating packages'
#' documentation.
#'
#' The \code{resetpar=FALSE} option keeps the actual graphics parameters
#' used for drawing the diagram. It allows for adding further graphic
#' elements like text annotations or auxiliary lines (e.g., a vertical
#' zero-line with \code{abline(v=0)}). It should prove useful especially
#' for the horizontal axis, as the theta-scale remains active.
#' The default TRUE returns to the R-defaults (margins, scale, ...)
#'
#' Note that using one of the internal palette definitions (e.g., warm1),
#' will also set the color of the information function (infcol).
#'
#' Note for R-Studio users: Setting extwin=TRUE will allow for defining
#' the graphics window's exact size. Note further that the new graphics
#' window will open in the back of the R-Studio.
#'
#'
#' @author Milica Kabic, Rainer W. Alexandrowicz
#'
#'
#' @references
#' Preston, K. S. J. & Reise, S. P. (2013).
#'    Estimating the Nominal Response Model Under Nonnormal Conditions.
#'    Educational and Psychological Measurement, 74(3) 377--399.
#'    <doi:10.1177/0013164413507063>
#'
#' de Ayala, R. J. (1993).
#'    An introduction to polytomous item response theory models.
#'    Measurement and Evaluation in Counseling and Development, 25(4), 172--189.
#'    <https://psycnet.apa.org/record/1993-28125-001>
#'
#' Samejima, F. (1969).
#'    Estimation of latent ability using a response pattern of graded scores.
#'    Psychometrika 34 (Supplement 1), 1--97. <doi:10.1007/BF03372160>
#'
#' O'Connor, B. P. (2018).
#'    An Illustration of the Effects of Fluctuations in Test Information on
#'    Measurement Error, the Attenuation of Effect Sizes, and Diagnostic Reliability.
#'    Psychological Assessment, 30 , 991--1003. <doi:10.1037/pas0000471>
#'
#' @examples
#'
#' library(RMX)
#' data(big5)
#'
#'   dat_extra = big5[,c(1,6,11,16)]
#'   dat_agree = big5[,c(2,7,12,17)]
#'   dat_consc = big5[,c(3,8,13,18)]
#'   dat_neuro = big5[,c(4,9,14,19)]
#'
#' library(eRm)
#'
#'# Note: each feature is accessible with each package!
#'
#'# 1 --- PCM with eRm (Extraversion)
#'
#'  res0 = PCM(dat_extra)                    # PCM
#'
#'  plotPIccc(res0)
#'
#'# 1.1 How to select only items Q6 and Q16?
#'  plotPIccc(res0, isel=c("Q6", "Q16"))
#'  plotPIccc(res0, isel=c(2,4))
#'
#'# 1.2 Turn off the Test Item Information (TIF)
#'  plotPIccc(res0, isel=c(2,4), TIF=FALSE)
#'
#'# 1.3 Turn off the selected Test Item Information (sTIF)
#'  plotPIccc(res0, isel=c(2,4), TIF=FALSE, sTIF=FALSE)
#'
#'# 1.4 Change color of functions and thresholds
#'  plotPIccc(res0, funcol="warm1")
#'
#'# 1.5 Create classical PImap
#'  plotPIccc(res0, funcol="warm1", classical=TRUE)
#'
#'\donttest{# examples might take a few seconds
#'# 2 --- GRM with mirt (Agreeableness)
#'
#' library(mirt)
#'
#'  res1 = mirt(dat_agree, 1, "graded")      # GRM
#'
#'  plotPIccc(res1)
#'
#'# 2.1 Sort the items according to their discrimination par (\alpha)
#'  plotPIccc(res1, isort = "disc")
#'
#'# 2.2 Show category + item information Functions
#'  plotPIccc(res1, type="BIF")
#'
#'# 2.3 "Zoom in" to see how item infotmation categories behave
#'  plotPIccc(res1, type="BIF", infomax="auto")
#'
#'# 2.4 Pick your PIccc
#'# ... only item functions and barplots
#'  plotPIccc(res1, type="BIF", funhprop = 1)
#'
#'# ... only item functions
#'  plotPIccc(res1, type="BIF", funhprop = 1, funwprop = 1)
#'
#'# ... only barplots
#'  plotPIccc(res1, type="BIF", funhprop = 1, funwprop = 0)
#'
#'# ... only person parameters
#'  plotPIccc(res1, type="BIF", funhprop = 0, funwprop = 1)
#'
#'# 2.5 Customise person part of the diagram
#'  plotPIccc(res1, type="BIF", funhprop = 0, funwprop = 1, breaks=20,
#'            tmin=-3, tmax=3, se_col = 1, TIF=FALSE, src=FALSE, dimcol="#40E0D0",
#'            main="Person Parameters with SE")
#'
#'# 3 --- GPCM with TAM (Conscienciousness)
#'
#' library(TAM)
#'
#'  res2 = tam.mml.2pl(dat_consc, verbose=FALSE,,control=list(maxiter=20)) # 2PL
#'
#'  plotPIccc(res2)
#'
#'# 3.1 higlight category 3
#'  plotPIccc(res2, highlight = 3)
#'
#'# 3.2 select only category 4
#'  plotPIccc(res2, csel = 4)
#'
#'# 3.3 hide threshold points
#'  plotPIccc(res2, csel = 4, thrpch = "")
#'
#'# 3.4 show detailed analysis of Item Q3
#'  plotPIccc(res2, isel = 1, type = c("CCC", "TCC", "BIF"))
#'
#'# 4 --- NRM with mirt (Neuroticism)
#'
#'  res3 = mirt(dat_neuro, 1, "nominal")     # NRM
#'
#'  plotPIccc(res3,isel=1:2)
#'
#'# 4.1 ordinality check with NRM (CBD Parameter; see Reise et al. 2021)
#'  plotPIccc(res3, isel=3:4, type="TCC") # Discrimination parameters of TCCs = CBD!
#'
#'}

# --------------------------------------------------------------------------------------------------

plotPIccc = function(resobj,
                     pp="auto",           # 2024-07-08 [RWA]
                     breaks="Sturges",
                     type="CCC",          # funtype: any of CCC,TCC,IIF,CIF,BIF
                     tmin=-6,
                     tmax=6,
                     isel=NULL,
                     ilab=NULL,
                     plab=c("none","abs","rel","den"),
                     dsel=NULL,
                     dlab=NULL, 
                     lmar=2,              # left margin (in lines)
                     ylas=0,              # 0=vertical, 1&2=horizontal
                     showlab=c(1:3,5:6),  # 0=FALSE, 1=horizontal, 2=vertical, 3=inner, 4=PP, 5=TIF, 6=SE)
                     isort="none",
                     gsort=FALSE,
                     infomax="equal",
                     height=7,                   # vtot
                     width=height*(sqrt(5)-1)/2, # htot
                     funhprop=0.7,               # vprop
                     funwprop=(sqrt(5)-1)/2,     # hprop
                     main=NULL,
                     csel=NULL, 

                     dimcol=c(grey(0.85),"steelblue1","lightcoral","orange"     ,"lightgreen"),
                     dencol=c(grey(0.5) ,"steelblue3","indianred3","darkorange2","limegreen"), # NA for omission
                     funcol="Rstandard",
                     infcol="black",
                     tifcol="seagreen4",    # NA for omission
                     se_col="firebrick4",   # --"--
                     relcol="red1",
                     bgcol=grey(.90),
                     gridcol="white",
                     usedimcol=FALSE,
                     highlight=NULL,

                     dens=FALSE,
                     TIF=TRUE,
                     sTIF=TRUE,
                     SE=TRUE,
                     sSE=TRUE,
                     REL=FALSE,
                     sREL=FALSE,
                     TIFmax="auto",
                     SEmax="auto",

                     funlty=1, 
                     funlwd=2,  

                     disind="*",          # dispch, disind, disorderd
                     discol= grey(0.2),
                     discex=1.5,

                     legend=TRUE, 
                     legoff=0.1,
                     legcex=0.7,
                     leglsp=1,

                     thrpch=16,           # threshold point size
                     thrsup=TRUE,         # threshold support lines

                     src=TRUE,
                     grid=TRUE,
                     classical=FALSE,
                     plot=TRUE,
                     extwin=NULL,
                     resetpar=TRUE,
                     debug=FALSE,

                     empirical=FALSE,
                     emptype="line",
                     empbins=NULL,
                     empcuts=NULL,
                     empsize=0.8,
                     emplwd=1,
                     emplty=1,
                     emppch=20,
                     smoothrange=NULL,
                     smoothargs=NULL,
                     skipfun=FALSE

                     ){


  if (is.null(main)) tmar = 0 else tmar = 2

  stopifnot("Argument 'tmax' must be larger than 'tmin'+1" = tmax > tmin+1)
  theta=seq(tmin,tmax,(tmax-tmin)/1000)

  type = toupper(type)
  stopifnot("Argument 'type' must be 'CCC','TCC','IIF','CIF', 'BIF', or 'ESC" = type %in% c("CCC","TCC","IIF","CIF","BIF","ESC"))
  stopifnot("Argument 'showlab' must be any combination of 0,1,2,3,4,5,6" = showlab %in% 0:6)
  stopifnot("Argument 'gsort' must be logical." = is.logical(gsort))
  stopifnot("Argument 'emptype' must be 'points','line','both','spline', 'loess' or 'none'" = emptype %in% c("points", "line", "both", "spline", "loess", "none"))
  
  if("none" %in% empirical) empirical = "none"
  if(sum("none" %in% empirical) != 0 & skipfun==TRUE){
    skipfun=FALSE
    warning("'empirical' argument contains argument 'none' and skipfun was set to TRUE. skipfun will be ignored.\n For plot without model functions use 'classical=TRUE'")
  }
  
  
#  if(is.null(thrsup) | is.null(thrpch)){
#    if(sum("none" %in% emptype) == 0){
#      thrsup=FALSE
#      thrpch=NA
#    }else{
#      thrsup=TRUE
#      thrpch=16
#    }
#  }
  

  stopifnot(is.numeric(funhprop) | length(funhprop) > 1)
  if(funhprop < 0 | funhprop > 1) stop("Invalid input for funhprop! Please use only numerical input between 0 and 1.\n")

  stopifnot(is.numeric(funwprop) | length(funwprop) > 1)
  if(funwprop < 0 | funwprop > 1) stop("Invalid input for funwprop! Please use only numerical input between 0 and 1.\n")
  
  if (is.null(isel) & length(type) > 1) stop("Multiple type diagrams require an item specification (isel).")
  if (length(type) > 1 & (length(isel) > 1 | length(dsel) > 1)) stop("Multiple type diagrams only for one item and one dimension possible.")

  if (!is.null(isel) & !is.null(dsel)) {
      warning("Both 'isel' and 'dsel' were set. Only 'dsel' will be used.")
      isel = NULL
  }

  if (is.null(extwin)) {
      if (.Platform$GUI == "RStudio") extwin=FALSE else extwin=TRUE
  }
  
  if(!is.null(csel)) thrsup=FALSE


 # if (TIF  && is.na(tifcol)) stop("Please provide a valid TIF color")
 # if (SE   && is.na(se_col)) stop("Please provide a valid SE color")
 # if (sTIF && is.na(tifcol)) stop("Please provide a valid TIF color")
 # if (sSE  && is.na(se_col)) stop("Please provide a valid SE color")

  if(is.null(isel)){
     sTIF = FALSE
     sSE  = FALSE
  }

  if (!infomax %in% c("auto","equal") & !is.numeric(infomax)) stop(paste("The infomax= option requires one of the keywords 'auto' or 'equal' or a valid numeric maximum:",infomax))

# nix = is.null(dev.list())           # no window open
# orig.par = par(no.readonly = TRUE)  # opens a window
# orig.pal = palette()
# if (nix) dev.off()                  # dirty hack (see https://stackoverflow.com/questions/24850788/)
                                      # r-preventing-par-from-opening-a-new-window-when-querying-for-grahical-paramet?noredirect=1&lq=1

  if (is.character(pp) && pp=="skip") funhprop = 1
  if (classical)  funwprop = 1

  if (funcol[1] == "Rstandard") {
      palette("R4")
      usecol = palette()[2:8]
  } else if (funcol[1] == "rainbow10") {
      usecol = rainbow(10)
      infcol = "black"
  } else if (funcol[1] == "warm1") {
      usecol = c("#ffd438", "#f3a94b", "#e77e5e", "#db5270", "#cf2783")
      infcol = "black"
  } else if (funcol[1] == "cool1") {
      usecol = c("#79fcff", "#6addf9", "#5cbef3", "#4d9eed", "#3e7fe7")
      infcol = "black"
  } else if (funcol[1] == "contrast1") {
      usecol = c("#fbff34", "#edc461", "#df898e", "#d04ebb", "#c213e8")
      infcol = "black"
  } else if (funcol[1] == "colorful1"){
      usecol = c("dodgerblue", "chartreuse3", "gold1", "chocolate3", "darkred")
      infcol = "black"
  } else {
      usecol = funcol
      infcol = infcol
  }
  
  if(!is.null(highlight)) stopifnot(is.numeric(highlight))
#  if(!is.null(csel) & (type=="TCC"| type=="IIF")) csel=NULL

  extobj = decider(resobj, pp=pp, debug=debug)

  clnobj = cleaner(extobj, isel=isel, ilab=ilab, dsel=dsel, dlab=dlab,
                           csel=csel, how_sort=isort, tot_sort=gsort, 
                           theta=theta, highlight=highlight, empbins=empbins,
                           empcuts=empcuts, smoothrange=smoothrange,
                           smoothargs=smoothargs, empirical=empirical,
#                           emptype=emptype,
                           debug=debug)

  if(plot) drawer(clnobj, theta=theta,type=type,height=height,width=width,
                          funhprop=funhprop,funwprop=funwprop,funcol=usecol,
                          infcol=infcol,funlty=funlty,funlwd=funlwd,bg=bgcol,
                          legend=legend,grid=grid,classical=classical,
                          thrsup=thrsup,thrpch=thrpch,src=src,pplab=plab,
                          dcol=dimcol,legcex=legcex,leglsp=leglsp,legoff=legoff,
                          disind=disind,discol=discol,lmar=lmar,tmar=tmar,main=main,
                          ylas=ylas,tifcol=tifcol,se_col=se_col,showlab=showlab,
                          dencol=dencol,gridcol=gridcol,usedimcol=usedimcol,
                          relcol=relcol,dens=dens,
                          TIF=TIF,sTIF=sTIF,SE=SE,sSE=sSE,REL=REL,sREL=sREL,
                          SEmax=SEmax,
                          TIFmax=TIFmax,infomax=infomax,extwin=extwin,debug=debug,
                          discex=discex,csel=csel, highlight=highlight,
                          empirical=empirical,
                          emptype=emptype,
                          empsize=empsize,
                          empbins=empbins,
                          emplwd=emplwd,
                          emplty=emplty,
                          emppch=emppch,
                          resetpar=resetpar,breaks=breaks, skipfun=skipfun)

  return(invisible(clnobj))

} # end of fun plotPIccc

ext_mirt = function(resobj, pp=NULL, defined=TRUE, debug=TRUE){
 
  if (debug) message("Entering mirt-extractor...")


  if(!inherits(resobj,"SingleGroupClass")) stop(paste("Class",class(resobj),"is incompatible with PIccc!"))
  
  itmodel = mirt::extract.mirt(resobj, what="itemtype")                         # which model?
  allcoef = mirt::coef(resobj)                                                        # list of length items+1

  inum = length(allcoef)-1
  inam = mirt::extract.mirt(resobj, what="itemnames")

  dnum = mirt::extract.mirt(resobj, what="nfact")                               # get dimensions number
  dnam = mirt::extract.mirt(resobj, what="factorNames")                         # get dimensions names

  K    = mirt::extract.mirt(resobj, what="K")                                   # get max categories
  tnum = ifelse(any(itmodel == "nominal"), max(K), max(K)-1)                    # num. of thresholds
  arow = ifelse(any(itmodel == "nominal"), max(K), 1  )                         # row num for alpha array

  dims_list = vector(mode="list", length=dnum)                                  # final list
  names(dims_list) <- dnam
 


  if (is.character(pp) && pp=="auto") {
     #if (dnum==1) pp = mirt::fscores(resobj) else pp = fscores(resobj,QMC=TRUE)
         pp = mirt::fscores(resobj,QMC=dnum>1)
  } else if (!is.null(attr(pp,"pp"))) {
         pp = attr(pp,"pp")
         stopifnot("Please use the result object from mirt::fscores()." = is.matrix(pp))
  } else if (is.character(pp) && pp == "skip") {                       # 'skip' for RMX::RMD!
         pp = rbind(rep("skip",dnum))
  } else {
         stopifnot("Please use the result object from mirt::fscores()." = is.matrix(pp))
  }

  modset1 = c("Rasch", "2PL", "3PL", "3PLu", "4PL")
  modset2 = c("PCM", "gpcm", "nominal")
  modset3 = c("gpcmIRT", "rsm", "grsmIRT")
  modset4 =   "graded"
  
  # create container matrices for parameters

  alpha = array(NA, dim=c(arow, inum, dnum))
  thrsh = matrix(NA, tnum, inum)
  guess = rep(NA, inum)
  upper = rep(NA, inum)

  colnames(thrsh) = inam
  
  for(d in 1:dnum){
    for(i in 1:inum){

      tmp_i = rbind(allcoef[[i]])[1,]  # 2023-07-03: ignore SE; thx CG
      alpha[,i,d] = tmp_i[d]

          if(itmodel[i] == "Rasch" & length(tmp_i) == dnum+3){  # simple Rasch
            
             tt = -tmp_i[dnum+1]
 
          } else if(itmodel[i] %in% modset1[-1]){               # 2/3/4PL
        
             tt =  -tmp_i[dnum+1]/alpha[,i,d]
       
          } else if( (itmodel[i] == "Rasch" & length(tmp_i) > dnum+3) | itmodel[i] == "gpcm" ){ # PCM, GPCM
        
             tt = -diff(tmp_i[(dnum+K[i]+1):(dnum+2*K[i])])/alpha[,i,d]
    
          } else if(itmodel[[i]] == "nominal"){
       
             ak = tmp_i[(dnum+1):(dnum+K[i])]
             aa = ak*tmp_i[d] - mean(ak*tmp_i[d])
             if(dim(alpha)[1] > length(aa)) aa[dim(alpha)[1]] = NA # fill with NA

             dd = tmp_i[(dnum+1+K[i]) : (dnum+2*K[i])]
             tt = dd-mean(dd, na.rm = TRUE)
             alpha[,i,d] = aa

          } else if(itmodel[i] == "grsmIRT"){ # !!! grsm
            
             b  = tmp_i[(dnum+1):(dnum+max(K)-1)]  
             c  = tmp_i[length(tmp_i)]
             tt = -(b+c)
         
          } else if(itmodel[i] == "rsm"){
           
             b  = tmp_i[(dnum+1):(dnum+max(K)-1)]  
             c  = tmp_i[length(tmp_i)]
             tt = b-c
       
          } else if(itmodel[i] == "gpcmIRT"){
         
             tt = tmp_i[(dnum+1):(dnum+max(K)-1)]    # check: max(K) ???

          } else if(itmodel[i] == "graded"){
          
             dd = tmp_i[(dnum+1):(length(tmp_i))]  
             tt = -dd/alpha[,i,d]
          
          } else {
             warning(paste("Model: ", itmodel[i], "not yet implemented and will be ignored in the output!"))
          }
      if(itmodel[i] %in% c(modset1, modset2, modset3, modset4)){
      
        if(itmodel[i] %in% c("2PL", "3PL", "3PLu", "4PL")){
          guess[ i] =  tmp_i[dnum+2]
          upper[ i] =  tmp_i[dnum+3]
        }else{
          guess[ i] = 0
          upper[ i] = 1
        }
        
        if(length(tt) < nrow(thrsh)) tt = c(tt,rep(NA, nrow(thrsh)-length(tt)))
        thrsh[,i] = tt
        
      } # do not save previous calculations for undefined model
    } # end of iteration through items
    
  # remove undefined Items
    
  rm_check = rep(NA, inum)
  for(i in 1:inum) rm_check[i] = (sum(is.na(thrsh[,i])) != nrow(thrsh)) # thrsh and alpha have same dimensions
  if(sum(rm_check)==0) stop("No valid items were left for analysis!", call. = FALSE)
  
  dims_list[[d]]$thresholds     = thrsh         [,rm_check   ,drop=FALSE]
  dims_list[[d]]$discrimination = rbind(alpha   [,rm_check, d])
  dims_list[[d]]$guessing       = guess         [ rm_check]
  dims_list[[d]]$laziness       = upper         [ rm_check]
  dims_list[[d]]$model          = itmodel       [ rm_check]
  dims_list[[d]]$person_par     = pp[ ,d]
  
  # standard errors for parameters SE_par
  
  # if(resobj@Options$SE){
  #   seobj = coef(resobj, printSE=TRUE, IRTpars=TRUE)
  #   se    = do.call(rbind, lapply(seobj[-length(seobj)], "[", "SE",))
  # }
  
  # for now only empty container (problem multidimesional case)
  
  se.thresholds = t(matrix(NA, dim(dims_list[[d]]$thresholds)[1], dim(dims_list[[d]]$thresholds)[2]))
  se.discrimination = matrix(NA, dim(dims_list[[d]]$discrimination)[1], dim(dims_list[[d]]$discrimination)[2])
  se.guessing = rep(NA, inum)
  se.laziness = rep(NA, inum)
  
  
  if(defined){
    
    dd = dims_list[[d]]$discrimination != 0       # identify confirmatory models: a=0!
    td = apply(dd,2,all,na.rm=TRUE)
    
    dims_list[[d]]$thresholds     = dims_list[[d]]$thresholds    [,td, drop=FALSE]
    dims_list[[d]]$discrimination = dims_list[[d]]$discrimination[,td, drop=FALSE]
    dims_list[[d]]$guessing       = guess  [td]
    dims_list[[d]]$laziness       = upper  [td]
    dims_list[[d]]$model          = itmodel[td]
    dims_list[[d]]$person_par     = pp[ ,d]
    dims_list[[d]]$SE_par         = list(se.thresholds=se.thresholds,
                                         se.discrimination=se.discrimination,
                                         se.guessing=se.guessing,
                                         se.laziness=se.laziness)
    
  } # end of defined check
  
 } # end of iteration through dimensions
  
  dims_list$freq = apply(resobj@Data$data,2,table,simplify=FALSE)
  data = resobj@Data$data

  attr(dims_list,"source") = paste0("mirt/",unique(itmodel[ rm_check]))
  attr(dims_list,"pp")     = pp
  attr(dims_list,"data")   = data

  if (debug) message("Leaving mirt-extractor...")

  return(dims_list)
  
} # end of mirt_Extractor

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/piccc.r
\name{plotPIccc}
\alias{plotPIccc}
\title{RMX Rasch Modeling Extended: A Visualisation Tool for IRT Models}
\usage{
plotPIccc(
  resobj,
  pp = "auto",
  breaks = "Sturges",
  type = "CCC",
  tmin = -6,
  tmax = 6,
  isel = NULL,
  ilab = NULL,
  plab = c("none", "abs", "rel", "den"),
  dsel = NULL,
  dlab = NULL,
  lmar = 2,
  ylas = 0,
  showlab = c(1:3, 5:6),
  isort = "none",
  gsort = FALSE,
  infomax = "equal",
  height = 7,
  width = height * (sqrt(5) - 1)/2,
  funhprop = 0.7,
  funwprop = (sqrt(5) - 1)/2,
  main = NULL,
  csel = NULL,
  dimcol = c(grey(0.85), "steelblue1", "lightcoral", "orange", "lightgreen"),
  dencol = c(grey(0.5), "steelblue3", "indianred3", "darkorange2", "limegreen"),
  funcol = "Rstandard",
  infcol = "black",
  tifcol = "seagreen4",
  se_col = "firebrick4",
  relcol = "red1",
  bgcol = grey(0.9),
  gridcol = "white",
  usedimcol = FALSE,
  highlight = NULL,
  dens = FALSE,
  TIF = TRUE,
  sTIF = TRUE,
  SE = TRUE,
  sSE = TRUE,
  REL = FALSE,
  sREL = FALSE,
  TIFmax = "auto",
  SEmax = "auto",
  funlty = 1,
  funlwd = 2,
  disind = "*",
  discol = grey(0.2),
  discex = 1.5,
  legend = TRUE,
  legoff = 0.1,
  legcex = 0.7,
  leglsp = 1,
  thrpch = 16,
  thrsup = TRUE,
  src = TRUE,
  grid = TRUE,
  classical = FALSE,
  plot = TRUE,
  extwin = NULL,
  resetpar = TRUE,
  debug = FALSE,
  empirical = FALSE,
  emptype = "line",
  empbins = NULL,
  empcuts = NULL,
  empsize = 0.8,
  emplwd = 1,
  emplty = 1,
  emppch = 20,
  smoothrange = NULL,
  smoothargs = NULL,
  skipfun = FALSE
)
}
\arguments{
\item{resobj}{Result object of originating package. Compatible packages
are \code{eRm}, \code{psychotools}, \code{ltm}, \code{mirt},
and \code{TAM}. Supported models are 1-4PL Models, RM,
PCM, RSM, GPCM, GRM, GRSM, and NRM.}

\item{pp}{Provide previously calculated person parameter estimates
(practical if the estimation process is slow). In the
multidimensional case person parameters need to be provided
column wise in matrix form, i.e., first column = PP of
first dimension, ...).
If "auto" (default) the person parameters are determined
using the default function of the originating package.
The special option pp="skip" will omit the entire plot
and prevent the call to person parameter estimation to
speed up.}

\item{breaks}{Number of breaks for the person parameter histogram
(adopted from the base R hist function).}

\item{type}{The function type to plot. Possible options are:
\itemize{
\item CCC, the Category Characteristic Curve (default),
\item TCC, the Threshold Characteristic Curve,
\item IIF, the Item Information Function,
\item CIF, the Category Information Function, and
\item BIF, both the Category and Item information curves
\item ESC, the empirical score function.
} Multiple types may be plotted simultaneously if only one 
item is selected. (\code{length(isel)==1}).}

\item{tmin}{Minimum of theta range to plot.}

\item{tmax}{Maximum of theta range to plot.}

\item{isel}{Item selection. Select items either by their index on each
dimension or by their names. If an item is defined on
multiple dimensions, all instances will be used.}

\item{ilab}{Provide item labels (names) for plotting. Has priority over
\code{isel}.}

\item{plab}{Labels of person parameter diagramm:
\itemize{
\item \code{abs}: absolute frequencies,
\item \code{rel}: relative frequencies (in %),
\item \code{den}: density estimate values,
\item \code{none}: omit labels (default).
}}

\item{dsel}{Dimension selection. Same principle as for \code{isel}.}

\item{dlab}{Provide dimension labels for plotting. See \code{ilab} for
more information.}

\item{lmar}{Left margin (in lines).}

\item{ylas}{Specify alignment of the y-axis labels (e.g. \code{ylas=2.}
for horizontal labels).}

\item{showlab}{Vector of options in the range are 0:6:
0 = show no axis labels,
1 = show outer x-axis (theta range) labels,
2 = show outer y-axis (item labels),
3 = show inner y-axis labels of item function diagrams,
4 = show y-axis labels of person parameter distribution,
5 = show y-axis labels of SE and sSE line,
6 = show y-axis labels of TIF and sTIF line,
(default: 1:3).}

\item{isort}{Sorting way may be specified. Possible options are
\code{mean}, \code{var}, \code{min},
\code{max}, \code{range}, \code{disc},
\code{lazy}, \code{guess}, and \code{none} (default).}

\item{gsort}{Global sort. If \code{TRUE} all items will be sorted
across dimensions. If \code{FALSE} items will be sorted
within dimensions.}

\item{infomax}{Vertical scaling of information curves (i.e., CIF, IIF, and
BIF). Takes either one of the keywords
\itemize{
\item \code{auto} (maximize each plot) or
\item \code{equal} (same scaling for all visible
information functions), or
\item a number indicating the maximum to be shown.
}}

\item{height}{Specify the hight of the diagram window.}

\item{width}{Width of the diagram (default: the golden ratio to the height).}

\item{funhprop}{Proportions of the horizontal axis to be used for the
function plots. The value of 1 will show only the
functions, a value of 0 only the person parameters + legend(s).}

\item{funwprop}{Proportion of the vertical axis to be used for the functions.
A value of 1 will only draw the functions and
person parameter histograms, and a value of 0 frequency
barplots.}

\item{main}{Title string (e.g., for question wording or scale name).
If not NULL, the upper margin is set to 2, otherwise 0.}

\item{csel}{Category selection. Select categories to draw by category
indices. Only numerical values are allowed.
This is merely a graphical option and has no effect on
the calculation of related constructs (IIF or TIF).
Do not combinde \code{csel} with \code{highlight}.}

\item{dimcol}{Vector of dimension color for the person parameter histograms.}

\item{dencol}{Vector of color for the person parameter density lines.}

\item{funcol}{The color for functions and thresholds. Provide color vector
or one of the predefined color schemes
\itemize{
\item \code{Rstandard} (default),
\item \code{rainbow10} (up to 10 response categories),
\item \code{warm1} (up to 5 response categories),
\item \code{cool1} (up to 5 response categories), 
\item \code{contrast1} (up to 5 response categories) or
\item \code{colorful1} (up to 5 response categories).
}}

\item{infcol}{Specify a separate color for the item information function
curve (default: \code{black}).}

\item{tifcol}{Color of the test information function (TIF).}

\item{se_col}{Color of the standard error function.}

\item{relcol}{Color of the relative reliability function.}

\item{bgcol}{Background color of function plot areas.}

\item{gridcol}{Grid color in function plots.}

\item{usedimcol}{Use dimension colors for threshold points (classical only).}

\item{highlight}{Numerical vector containing the category numbers to be
highlighted (the others will be drawn in grey).
Do not combine \code{highlight} with \code{csel}.}

\item{dens}{Draw kernel density estimate of person parameter distribution
(default: TRUE).}

\item{TIF}{Draw test information function (default: TRUE).}

\item{sTIF}{Draw test information function of selected items (default: TRUE).}

\item{SE}{Draw standard error function (default: TRUE).}

\item{sSE}{Draw standard error function of selected items (default: TRUE).}

\item{REL}{Draw relative reliability (O'Connor, 2018, p.993, eq.6; default: FALSE).}

\item{sREL}{Draw relative reliability of selected items (default: FALSE).}

\item{TIFmax}{Maximum of test information function (default: "auto").}

\item{SEmax}{Maximum of standard error function (default: "auto").}

\item{funlty}{Line type of the functions, see \code{type}.}

\item{funlwd}{Line width of the functions.}

\item{disind}{Disordering indicator (default: \code{"*"}).}

\item{discol}{Color of the threshold disorder indicator (default: "red")}

\item{discex}{Size of the threshold disorder indicator (default: 1.5)}

\item{legend}{If \code{TRUE} (default) insert legend.}

\item{legoff}{Legend offset (vertical) from top margin (default: 0.1)}

\item{legcex}{Legend text size.}

\item{leglsp}{Legend line spacing.}

\item{thrpch}{Set threshold point character (NA to suppress).}

\item{thrsup}{If \code{TRUE} (default) plot threshold supporting lines.}

\item{src}{If \code{TRUE} write the originating package and the
estimated model in the bottom right corner.}

\item{grid}{If \code{TRUE} (default) draw a grid in the function area.}

\item{classical}{If \code{TRUE} plot the classical person-item map.}

\item{plot}{Plot the diagram (default: \code{TRUE})}

\item{extwin}{(logical) Draw diagram(s) into an external window (for
better compatibility with RStudio and drawing to an external
file (pdf, png, ...); default: \code{FALSE}).}

\item{resetpar}{Reset graphics parameter (default: \code{TRUE}).
If \code{FALSE}, the diagram coordinates remain, so that
further annotations can be made to the diagram (see Details).}

\item{debug}{(logical) Print call stack (might help tracking error).}

\item{empirical}{Show empirical curves? (boolean, default FALSE)
Applies only if \code{type=CCC}.}

\item{emptype}{Type of empirical ICC. Possible options are:
\itemize{
\item \code{points}
\item \code{line} (default)
\item \code{both}
\item \code{spline}
\item \code{loess}
\item \code{none}
}
Multiple types may be specified.}

\item{empbins}{Number of bins used for empirical curves.}

\item{empcuts}{Cut points for bins for empirical curves.
Takes precedence if both empbins and empcuts are specified,
with a warning.}

\item{empsize}{Size of points: Numerical (=cex) or string 'binsize', the
latter reflecting the size of the bins used for grouping.
(default: 0.8; if binsize: 0.5*exp(n per bin))}

\item{emplwd}{Line width of empirical curves (default: 1)}

\item{emplty}{Line type of empirical curves (takes values from plot/lty;
default: 1)}

\item{emppch}{Point character of empirical points (default: 20)}

\item{smoothrange}{Support of the smoothing function along the theta-axis
if emptype %in% c("spline","loess").
If \code{NULL} (default) the chosen interval of theta.}

\item{smoothargs}{Arguments to be forwarded to \code{stats::smooth.spline()}}

\item{skipfun}{Skip drawing of model-based ICC/CCC. Draws only the
empirical curve.}
}
\value{
\code{plotPIccc} returns a nested list containing:
      \itemize{
      \item one list element per dimension. Named by default \code{F1},
            \code{F2}, ..., but can be changed with the \code{dlab=} option.
      \item the element \code{freq} with the response frequencies of each
            item, and
      \item \code{sortvec} with the positions of the items as displayed.
      }
It further contains the attributes
      \itemize{
      \item \code{source}, indicating the package used for parameter
            estimation and the model,
      \item \code{pp}, a matrix with the estimated person parameters
            (used for avoiding re-estimation if plotPIccc is repeatedly called),
      \item \code{data}, the data set as returned from the originating package
      \item \code{theta}, the vector used for the horizontal axis.
      }
}
\description{
Provides a customizable function \code{plotPIccc()}, which draws classical
PImaps (Wright-Maps) with various graphical extensions, enabling the user
to get a quick and differentiated overview for psychometric analyses.
}
\details{
See Preston & Reise (2013) for the definition and interpretation of the
category boundary discrimination (CBD) and threshold characteristic curves
(TCCs) in NRM.
See de Ayala (1993) for the definition of the intersections in the NRM.
See Samejima (1969) for the definition of the category information curve.
For references concerning the supported models see the originating packages'
documentation.

The \code{resetpar=FALSE} option keeps the actual graphics parameters
used for drawing the diagram. It allows for adding further graphic
elements like text annotations or auxiliary lines (e.g., a vertical
zero-line with \code{abline(v=0)}). It should prove useful especially
for the horizontal axis, as the theta-scale remains active.
The default TRUE returns to the R-defaults (margins, scale, ...)

Note that using one of the internal palette definitions (e.g., warm1),
will also set the color of the information function (infcol).

Note for R-Studio users: Setting extwin=TRUE will allow for defining
the graphics window's exact size. Note further that the new graphics
window will open in the back of the R-Studio.
}
\examples{

library(RMX)
data(big5)

  dat_extra = big5[,c(1,6,11,16)]
  dat_agree = big5[,c(2,7,12,17)]
  dat_consc = big5[,c(3,8,13,18)]
  dat_neuro = big5[,c(4,9,14,19)]

library(eRm)

# Note: each feature is accessible with each package!

# 1 --- PCM with eRm (Extraversion)

 res0 = PCM(dat_extra)                    # PCM

 plotPIccc(res0)

# 1.1 How to select only items Q6 and Q16?
 plotPIccc(res0, isel=c("Q6", "Q16"))
 plotPIccc(res0, isel=c(2,4))

# 1.2 Turn off the Test Item Information (TIF)
 plotPIccc(res0, isel=c(2,4), TIF=FALSE)

# 1.3 Turn off the selected Test Item Information (sTIF)
 plotPIccc(res0, isel=c(2,4), TIF=FALSE, sTIF=FALSE)

# 1.4 Change color of functions and thresholds
 plotPIccc(res0, funcol="warm1")

# 1.5 Create classical PImap
 plotPIccc(res0, funcol="warm1", classical=TRUE)

\donttest{# examples might take a few seconds
# 2 --- GRM with mirt (Agreeableness)

library(mirt)

 res1 = mirt(dat_agree, 1, "graded")      # GRM

 plotPIccc(res1)

# 2.1 Sort the items according to their discrimination par (\alpha)
 plotPIccc(res1, isort = "disc")

# 2.2 Show category + item information Functions
 plotPIccc(res1, type="BIF")

# 2.3 "Zoom in" to see how item infotmation categories behave
 plotPIccc(res1, type="BIF", infomax="auto")

# 2.4 Pick your PIccc
# ... only item functions and barplots
 plotPIccc(res1, type="BIF", funhprop = 1)

# ... only item functions
 plotPIccc(res1, type="BIF", funhprop = 1, funwprop = 1)

# ... only barplots
 plotPIccc(res1, type="BIF", funhprop = 1, funwprop = 0)

# ... only person parameters
 plotPIccc(res1, type="BIF", funhprop = 0, funwprop = 1)

# 2.5 Customise person part of the diagram
 plotPIccc(res1, type="BIF", funhprop = 0, funwprop = 1, breaks=20,
           tmin=-3, tmax=3, se_col = 1, TIF=FALSE, src=FALSE, dimcol="#40E0D0",
           main="Person Parameters with SE")

# 3 --- GPCM with TAM (Conscienciousness)

library(TAM)

 res2 = tam.mml.2pl(dat_consc, verbose=FALSE,,control=list(maxiter=20)) # 2PL

 plotPIccc(res2)

# 3.1 higlight category 3
 plotPIccc(res2, highlight = 3)

# 3.2 select only category 4
 plotPIccc(res2, csel = 4)

# 3.3 hide threshold points
 plotPIccc(res2, csel = 4, thrpch = "")

# 3.4 show detailed analysis of Item Q3
 plotPIccc(res2, isel = 1, type = c("CCC", "TCC", "BIF"))

# 4 --- NRM with mirt (Neuroticism)

 res3 = mirt(dat_neuro, 1, "nominal")     # NRM

 plotPIccc(res3,isel=1:2)

# 4.1 ordinality check with NRM (CBD Parameter; see Reise et al. 2021)
 plotPIccc(res3, isel=3:4, type="TCC") # Discrimination parameters of TCCs = CBD!

}
}
\references{
Preston, K. S. J. & Reise, S. P. (2013).
   Estimating the Nominal Response Model Under Nonnormal Conditions.
   Educational and Psychological Measurement, 74(3) 377--399.
   <doi:10.1177/0013164413507063>

de Ayala, R. J. (1993).
   An introduction to polytomous item response theory models.
   Measurement and Evaluation in Counseling and Development, 25(4), 172--189.
   <https://psycnet.apa.org/record/1993-28125-001>

Samejima, F. (1969).
   Estimation of latent ability using a response pattern of graded scores.
   Psychometrika 34 (Supplement 1), 1--97. <doi:10.1007/BF03372160>

O'Connor, B. P. (2018).
   An Illustration of the Effects of Fluctuations in Test Information on
   Measurement Error, the Attenuation of Effect Sizes, and Diagnostic Reliability.
   Psychological Assessment, 30 , 991--1003. <doi:10.1037/pas0000471>
}
\author{
Milica Kabic, Rainer W. Alexandrowicz
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/big5.r
\docType{data}
\name{big5}
\alias{big5}
\title{BIG 5 Example Data Set}
\format{
A data.frame with 1076 rows and 21 columns.
}
\usage{
big5
}
\description{
Description: A data set simulated after a students survey of the BIG 5 
(Openness [O], Conscienciousness [C], Extraversion [E], Agreeableness [A], 
and Neuroticism [N]). The scale comprises 21 items following the structure 
of the BFIK (DOI 10.1026/0012-1924.51.4.195).
}
\details{
The items were originally presented in German. Here is
a rough translation (untested):
\describe{
\item{Q1R }{[E] I ... am rather reserved.}
\item{Q2R }{[A] I ... tend to criticize others.}
\item{Q3  }{[C] I ... complete tasks thoroughly.}
\item{Q4  }{[N] I ... get depressed easily, depressed.}
\item{Q5  }{[O] I ... am interested in many things.}
\item{Q6  }{[E] I ... am enthusiastic and can easily carry others away.}
\item{Q7  }{[A] I ... trust others easily, believe in the good in people.}
\item{Q8R }{[C] I ... am comfortable, tend to laziness.}
\item{Q9R }{[N] I ... am relaxed, do not let stress upset me.}
\item{Q10 }{[O] I ... am profound, like to think about things.}
\item{Q11R}{[E] I ... am rather the 'quiet type', taciturn.}
\item{Q12R}{[A] I ... can act cold and distant.}
\item{Q13 }{[C] I ... am efficient and work briskly.}
\item{Q14 }{[N] I ... worry a lot.}
\item{Q15 }{[O] I ... have an active imagination, am imaginative.}
\item{Q16 }{[E] I ... go out of myself, am sociable.}
\item{Q17R}{[A] I ... can be brusque and dismissive towards others.}
\item{Q18 }{[C] I ... make plans and carry them out.}
\item{Q19 }{[N] I ... get nervous and insecure easily.}
\item{Q20 }{[O] I ... appreciate artistic and aesthetic impressions.}
\item{Q21R}{[O] I ... have little artistic interest.}
}
The response format of all items was:
\itemize{
\item very inapplicable 
\item rather inapplicable 
\item neither-nor 
\item rather true  
\item very true
}
}
\examples{
 library(RMX)
 summary(big5)
}
\keyword{datasets}
